#include "stdafx.h"

#ifndef _HOOK_H_
#define _HOOK_H_

#define LITTLE_ENDIAN_WORD(wValue) \
	(WORD)((((wValue) & 0xFF00) >> 8) | (((wValue) & 0x00FF) << 8))
#define LITTLE_ENDIAN_DWORD(dwValue) \
	(DWORD)((((dwValue) & 0xFF000000) >> 24) | (((dwValue) & 0x00FF0000) >> 8) | (((dwValue) & 0x0000FF00) << 8) | (((dwValue) & 0x000000FF) << 24))

// Little Endian bytes order.
enum EInstructionOpcodes : unsigned long {
	INSTR_PUSH_EBP					= 0x55,
	INSTR_PUSH_ESI					= 0x56,
	INSTR_PUSH_EDI					= 0x57,
	INSTR_POP_EBX					= 0x5B,
	INSTR_POP_ESI					= 0x5E,
	INSTR_POP_EDI					= 0x5F,
	INSTR_PUSH_IMM32				= 0x68,
	INSTR_JNS_OFF8					= 0x79,
	INSTR_JP_OFF8					= 0x7A,
	INSTR_JGE_OFF8					= 0x7D,
	INSTR_JL_OFF8					= 0x7C,
	INSTR_NOP						= 0x90,
	INSTR_MOV_AL_IMM8				= 0xB0,
	INSTR_MOV_EAX_IMM32				= 0xB8,
	INSTR_MOV_EBX_IMM32				= 0xBB,
	INSTR_MOV_EBP_IMM32				= 0xBD,
	INSTR_CALL_OFF32				= 0xE8,
	INSTR_JMP_OFF32					= 0xE9,
	INSTR_JMP_OFF8					= 0xEB,
	INSTR_XOR_EAX_EAX				= 0x33C0,
	INSTR_XOR_EDI_EDI				= 0x33FF,
	INSTR_ADD_ESP_IMM8				= 0x83C4,
	INSTR_SUB_ESP_IMM8				= 0x83EC,
	INSTR_FADD_ST0_STI				= 0xD8C0,
	INSTR_FSUB_ST0_STI				= 0xD8E0,
	INSTR_FLD_PTR32					= 0xD905,
	INSTR_FLD_STI					= 0xD9C0,
	INSTR_FPTAN						= 0xD9F2,
	INSTR_FILD_PTR32				= 0xDB05,
	INSTR_FSTP_STI					= 0xDDD8,
	INSTR_FADDP_STI_ST0				= 0xDEC0,
	INSTR_MOV_PTR32ESPADDOFF8_EDI	= 0x00897C24,
	INSTR_MOV_EBP_PTR32ESPADDOFF8	= 0x008B6C24,
	INSTR_LEA_ECX_PTR32ESPADDOFF8	= 0x008D4C24,
	INSTR_FADD_PTR32ESPADDOFF8		= 0x00D84424,
	INSTR_FLD_PTR32ESPADDOFF8		= 0x00D94424,
	INSTR_FSTP_PTR32ESPADDOFF8		= 0x00D95C24,
	INSTR_FILD_PTR32ESPADDOFF8		= 0x00DB4424,
	INSTR_MOV_PTR8ESPADDOFF8_IMM8	= 0x00C64424
};

void WINAPI InstallHookJmp(LPVOID lpvSourceAddr, LPVOID lpvDestAddr);
void WINAPI InstallHookJmpShort(LPVOID lpvSourceAddr, LPVOID lpvDestAddr);
void WINAPI InstallHookCall(LPVOID lpvSourceAddr, LPVOID lpvDestAddr);
void WINAPI InstallHookAddr(LPVOID lpvSourceAddr, LPVOID lpvDestAddr);
void WINAPI InstallHookOff(LPVOID lpvSourceAddr, LPVOID lpvDestAddr);
void WINAPI InstallHookOffShort(LPVOID lpvSourceAddr, LPVOID lpvDestAddr);
template<typename TValue>
void WINAPI WriteProtectedMemory(LPVOID lpvAddress, TValue tValue);
void WINAPI NopProtectedMemory(LPVOID lpvAddress, DWORD dwBytes);
void WINAPI InstallAllHooks();

void drawText();
char *getDisplayModeAdapterIdName(int iAdapter);
char *getDisplayModeFormatName(D3DFORMAT eFormat);
float getHeightInWorldLevel(float fPosZ);
float getHeightPercentInWorldLevel(float fPosZ);
short findTextKeyIndex(unsigned int uiKey, CTextKey *paclTextKeys, short sFirst, short sLast);
CTextKey *addTextKeyInSortedList(unsigned int uiKey, char *pszData, CTextKey *paclTextKeys);

float getDynamicScreenFieldOfView(float fFactor);
void setScreenFieldOfView(float fFactor);
void updateScreenAspectRatio();
//float __stdcall scaleToWideScreenWidth(float fCoordX);
//float __stdcall scaleToWideScreenHeight(float fCoordY);
void setVideo(int iModeIndex, int iRatioIndex);
void setVideoRatio(int iRatioIndex);
void rwD3d9CreateDisplayRatioList();
bool rwD3d9ChangeDisplayRatio(int iRatioIndex);
int rwEngineGetNumVideoRatios();
int rwEngineGetCurrentVideoModeRatio(int iModeIndex);
int rwEngineGetCurrentVideoRatio();
SRwVideoRatio *rwEngineGetVideoRatioInfo(SRwVideoRatio *pstRatioInfo, int iRatioIndex);
bool rwEngineSetVideoRatio(int iRatioIndex);
char *psGetVideoMode(char *pszVideoMode, int iModeIndex);
char *psGetVideoRatio(char *pszVideoRatio, int iRatioIndex);

void HOOK_PTR_0043CFE8_drawRampageCounter();
void HOOK_PTR_0045506D_drawPickupMoneyText();
void HOOK_PTR_005736B6_CMenuManager__setPage();
void HOOK_PTR_00573BDF_CMenuManager__resetPageSettings();
void HOOK_PTR_00574037_CMenuManager__drawMessage();
void HOOK_PTR_00574075_CMenuManager__drawMessage();
void HOOK_PTR_005740D5_CMenuManager__drawMessage();
void HOOK_PTR_00574198_CMenuManager__drawMessage();
void HOOK_PTR_00574213_CMenuManager__drawMessage();
void HOOK_PTR_00574252_CMenuManager__drawMessage();
void HOOK_PTR_005746FE_CMenuManager__drawRadioStationSprites();
void HOOK_PTR_0057471D_CMenuManager__drawRadioStationSprites();
void HOOK_PTR_005747E8_CMenuManager__drawRadioStationSprites();
void HOOK_PTR_00574811_CMenuManager__drawRadioStationSprites();
void HOOK_PTR_0057495C_CMenuManager__drawStats();
void HOOK_PTR_00574EB4_CMenuManager__drawStats();
void HOOK_PTR_00574FD1_CMenuManager__drawStats();
//void HOOK_PTR_00575B6A_CMenuManager__drawMap();
void HOOK_PTR_00575E96_CMenuManager__drawMap();
void HOOK_PTR_005760FD_CMenuManager__drawMap();
void HOOK_PTR_00576379_CMenuManager__drawBriefs();
void HOOK_PTR_0057657C_CMenuManager__drawBriefs();
void HOOK_PTR_005766EB_CMenuManager__drawBriefs();
void HOOK_PTR_00576955_CMenuManager__drawEntryBars();
void HOOK_PTR_00578FFC_CMenuManager__drawWindowText();
void HOOK_PTR_00579081_CMenuManager__drawWindowText();
void HOOK_PTR_005790D4_CMenuManager__drawWindowText();
void HOOK_PTR_00579316_CMenuManager__drawWindowText();
void HOOK_PTR_00579591_CMenuManager__drawEntries();
void HOOK_PTR_005796DA_CMenuManager__drawEntries();
void HOOK_PTR_00579936_CMenuManager__drawEntries();
void HOOK_PTR_005799B3_CMenuManager__drawEntries();
void HOOK_PTR_00579CA8_CMenuManager__drawEntries();
void HOOK_PTR_0057A244_CMenuManager__drawEntries();
void HOOK_PTR_0057A2C0_CMenuManager__drawEntries();
void HOOK_PTR_0057A32A_CMenuManager__drawEntries();
void HOOK_PTR_0057A45C_CMenuManager__drawEntries();
void HOOK_PTR_0057A55B_CMenuManager__drawEntries();
void CODE_0_CMenuManager__drawEntries();
void CODE_1_CMenuManager__drawEntries();
void CODE_2_CMenuManager__drawEntries();
void CODE_3_CMenuManager__drawEntries();
void CODE_4_CMenuManager__drawEntries();
void CODE_5_CMenuManager__drawEntries();
void HOOK_PTR_0057B144_CMenuManager__drawEntries();
void HOOK_PTR_0057B1A2_CMenuManager__drawEntries();
void HOOK_PTR_0057B215_CMenuManager__drawEntries();
void HOOK_PTR_0057B9C0_CMenuManager__drawPage();
void CODE_0_CMenuManager__drawPage();
void CODE_1_CMenuManager__drawPage();
void CODE_2_CMenuManager__drawPage();
void HOOK_PTR_0057BCD3_CMenuManager__drawPage();
void HOOK_PTR_0057BD75_CMenuManager__drawPage();
void HOOK_PTR_0057C043_CMenuManager__drawPage();
void HOOK_PTR_0057C135_CMenuManager__drawPage();
void CODE_3_CMenuManager__drawPage();
void HOOK_PTR_0057C1BD_CMenuManager__drawPage();
void CODE_0_CMenuManager__updateEntrySetting();
void CODE_1_CMenuManager__updateEntrySetting();
void HOOK_PTR_0057D8E9_CMenuManager__drawDebugInputs();
void HOOK_PTR_0057DA79_CMenuManager__drawDebugInputs();
void HOOK_PTR_0057E250_CMenuManager__drawBottomMessage();
void HOOK_PTR_0057E734_CMenuManager__drawInputs();
void HOOK_PTR_0057EA24_CMenuManager__drawInputs();
void HOOK_PTR_0057EB0E_CMenuManager__drawInputs();
void HOOK_PTR_0057EDB9_CMenuManager__drawInputs();
void HOOK_PTR_0057EFE8_CMenuManager__processController();
void HOOK_PTR_0057F235_CMenuManager__processController();
void HOOK_PTR_0057F2A3_CMenuManager__processController();
void HOOK_PTR_0057F693_CMenuManager__drawControls();
void HOOK_PTR_0057F794_CMenuManager__drawControls();
void HOOK_PTR_0057F7DB_CMenuManager__drawControls();
void HOOK_PTR_0057F8C2_CMenuManager__drawControls();
void HOOK_PTR_0057F91A_CMenuManager__drawControls();
void HOOK_PTR_0057FA18_CMenuManager__drawControls();
void HOOK_PTR_0057FA6F_CMenuManager__drawControls();
void HOOK_PTR_0057FAF3_CMenuManager__drawControls();
void HOOK_PTR_0057FCCC_CMenuManager__drawControls();
void HOOK_PTR_00582E21_CMenuManager__drawMapLegend();
void HOOK_PTR_00588223_drawBlips();
void HOOK_PTR_005886B9_drawBlips();
void HOOK_PTR_00589709_drawStatistics();
void HOOK_PTR_0058A68F_drawMap();
void HOOK_PTR_0058B1B4_drawOnScreenDisplays();
void HOOK_PTR_0058BF9C_drawMessageBox();
void HOOK_PTR_005A867B_drawCreditText();
void HOOK_PTR_005A881E_drawCredits();
void HOOK_PTR_005A883A_drawCredits();
void HOOK_PTR_0070CEAD_transform3DTo2DPointInClip();
void HOOK_PTR_0071A63C_getTextRect();
void HOOK_PTR_0071DA42_transform3DTo2DPoint();
void CODE_0_transform3DTo2DPoint();
void HOOK_PTR_007462BF_psSelectDevice();
void HOOK_PTR_007462F4_psSelectDevice();
void HOOK_OFF_04F2_rwD3d9System();
void CODE_0_rwD3d9System();
void CODE_1_rwD3d9System();
void CODE_2_rwD3d9System();
void CODE_3_rwD3d9System();
void CODE_4_rwD3d9System();
void CODE_5_rwD3d9System();
void HOOK_OFF_01_rwD3d9Release();

#endif // ndef _HOOK_H_
