#include "stdafx.h"
#include "hook.h"

float fScreenAspectRatioAcd = SCREEN_AR_ACADEMY;
float fInvScreenAspectRatioAcd = 1.0f / SCREEN_AR_ACADEMY;
float fScreenFieldOfViewHStd = SCREEN_FOV_HORIZONTAL;
float fScreenFieldOfViewVStd = SCREEN_FOV_VERTICAL;

float fWideScreenWidthRatio, fWideScreenHeightRatio;
float fWideScreenWidthPerc, fWideScreenHeightPerc;
float fWideScreenWidthDiff, fWideScreenHeightDiff;
float fWideScreenWidthMult, fWideScreenHeightMult;
float fWideScreenWidthScaleUp, fWideScreenHeightScaleUp;
float fWideScreenWidthScaleMid, fWideScreenHeightScaleMid;
float fWideScreenWidthScaleDown, fWideScreenHeightScaleDown;
float fWideScreenWidthScaled, fWideScreenHeightScaled;
float fWideScreenWidthScaledInv, fWideScreenHeightScaledInv;

float fDynamicScreenFieldOfViewScale;

SRwD3d9DisplayRatio *pastRwDisplayRatioList, stRwDisplayRatio;
int iRwNumDisplayRatios, iRwCurrentDisplayRatio;
char cCurSelVideoRatio = -1, cSelectedVideoRatio;

LPVOID alpvD3d9SystemJumpTable[28];

void WINAPI InstallHookJmp(LPVOID lpvSourceAddr, LPVOID lpvDestAddr) {
	DWORD dwProtect[2];

	VirtualProtect(lpvSourceAddr, 5, PAGE_EXECUTE_READWRITE, &dwProtect[0]);
	*(BYTE *)lpvSourceAddr = INSTR_JMP_OFF32;
	*(DWORD *)((PBYTE)lpvSourceAddr + 0x01) = (DWORD)lpvDestAddr - ((DWORD)lpvSourceAddr + 0x05);
	VirtualProtect(lpvSourceAddr, 5, dwProtect[0], &dwProtect[1]);
}

void WINAPI InstallHookJmpShort(LPVOID lpvSourceAddr, LPVOID lpvDestAddr) {
	DWORD dwProtect[2];

	VirtualProtect(lpvSourceAddr, 2, PAGE_EXECUTE_READWRITE, &dwProtect[0]);
	*(BYTE *)lpvSourceAddr = INSTR_JMP_OFF8;
	*((PBYTE)lpvSourceAddr + 0x01) = (BYTE)lpvDestAddr - ((BYTE)lpvSourceAddr + 0x02);
	VirtualProtect(lpvSourceAddr, 2, dwProtect[0], &dwProtect[1]);
}

void WINAPI InstallHookCall(LPVOID lpvSourceAddr, LPVOID lpvDestAddr) {
	DWORD dwProtect[2];

	VirtualProtect(lpvSourceAddr, 5, PAGE_EXECUTE_READWRITE, &dwProtect[0]);
	*(BYTE *)lpvSourceAddr = INSTR_CALL_OFF32;
	*(DWORD *)((PBYTE)lpvSourceAddr + 0x01) = (DWORD)lpvDestAddr - ((DWORD)lpvSourceAddr + 0x05);
	VirtualProtect(lpvSourceAddr, 5, dwProtect[0], &dwProtect[1]);
}

void WINAPI InstallHookAddr(LPVOID lpvSourceAddr, LPVOID lpvDestAddr) {
	DWORD dwProtect[2];

	VirtualProtect(lpvSourceAddr, 4, PAGE_EXECUTE_READWRITE, &dwProtect[0]);
	*(DWORD *)lpvSourceAddr = (DWORD)lpvDestAddr;
	VirtualProtect(lpvSourceAddr, 4, dwProtect[0], &dwProtect[1]);
}

void WINAPI InstallHookOff(LPVOID lpvSourceAddr, LPVOID lpvDestAddr) {
	DWORD dwProtect[2];

	VirtualProtect(lpvSourceAddr, 4, PAGE_EXECUTE_READWRITE, &dwProtect[0]);
	*(DWORD *)lpvSourceAddr = (DWORD)lpvDestAddr - ((DWORD)lpvSourceAddr + 0x04);
	VirtualProtect(lpvSourceAddr, 4, dwProtect[0], &dwProtect[1]);
}

void WINAPI InstallHookOffShort(LPVOID lpvSourceAddr, LPVOID lpvDestAddr) {
	DWORD dwProtect[2];

	VirtualProtect(lpvSourceAddr, 1, PAGE_EXECUTE_READWRITE, &dwProtect[0]);
	*(BYTE *)lpvSourceAddr = (BYTE)lpvDestAddr - ((BYTE)lpvSourceAddr + 0x01);
	VirtualProtect(lpvSourceAddr, 1, dwProtect[0], &dwProtect[1]);
}

template<typename TValue>
void WINAPI WriteProtectedMemory(LPVOID lpvAddress, TValue tValue) {
	DWORD dwProtect[2];

	VirtualProtect(lpvAddress, sizeof(TValue), PAGE_EXECUTE_READWRITE, &dwProtect[0]);
	*(TValue *)lpvAddress = tValue;
	VirtualProtect(lpvAddress, sizeof(TValue), dwProtect[0], &dwProtect[1]);
}

void WINAPI NopProtectedMemory(LPVOID lpvAddress, DWORD dwBytes) {
	DWORD dwProtect[2];

	VirtualProtect(lpvAddress, dwBytes, PAGE_EXECUTE_READWRITE, &dwProtect[0]);

	switch(dwBytes) {
		case sizeof(BYTE):
			*(BYTE *)lpvAddress = INSTR_NOP;
			break;
		case sizeof(WORD):
			*(WORD *)lpvAddress = (INSTR_NOP << 8) | INSTR_NOP;
			break;
		case sizeof(DWORD):
			*(DWORD *)lpvAddress = (INSTR_NOP << 24) | (INSTR_NOP << 16) | (INSTR_NOP << 8) | INSTR_NOP;
			break;
		default:
			memset(lpvAddress, INSTR_NOP, dwBytes);
	}

	VirtualProtect(lpvAddress, dwBytes, dwProtect[0], &dwProtect[1]);
}

#define ADDR_0050AD51_CCamera__0050AD40	0x0050AD51
#define ADDR_0051008C_CCam__0050F970	0x0051008C
#define ADDR_005102DB_CCam__0050F970	0x005102DB
#define ADDR_00513F2E_CCam__00513E40	0x00513F2E
#define ADDR_005143B4_CCam__00514030	0x005143B4
#define ADDR_00514984_CCamera__00514970	0x00514984
#define ADDR_0051A22A_CCam__00519810	0x0051A22A
#define ADDR_00521994_CCam__00521500	0x00521994
#define ADDR_0056EDA1_CPed__0056EC80	0x0056EDA1

void __declspec(naked) HOOK_CCamera__0050AD4A() {
	__asm {
		fld		[eax+ecx]CCamera.m_aclCams.m_fZoomFactor
		fmul	fDynamicScreenFieldOfViewScale
		mov		edx, ADDR_0050AD51_CCamera__0050AD40
		jmp		edx
	}
}

void __declspec(naked) HOOK_CCam__00510086() {
	__asm {
		fld		[edi]CCam.m_fZoomFactor
		fmul	fDynamicScreenFieldOfViewScale
		mov		eax, ADDR_0051008C_CCam__0050F970
		jmp		eax
	}
}

void __declspec(naked) HOOK_CCam__005102D5() {
	__asm {
		fld		[edi]CCam.m_fZoomFactor
		fmul	fDynamicScreenFieldOfViewScale
		mov		eax, ADDR_005102DB_CCam__0050F970
		jmp		eax
	}
}

void __declspec(naked) HOOK_CCam__00513F28() {
	__asm {
		fld		[esi]CCam.m_fZoomFactor
		fmul	fDynamicScreenFieldOfViewScale
		mov		eax, ADDR_00513F2E_CCam__00513E40
		jmp		eax
	}
}

void __declspec(naked) HOOK_CCam__005143AD() {
	__asm {
		fld		dword ptr [esp+8Ch+10h]
		fmul	fDynamicScreenFieldOfViewScale
		mov		eax, ADDR_005143B4_CCam__00514030
		jmp		eax
	}
}

void __declspec(naked) HOOK_CCamera__0051497D() {
	__asm {
		fld		[eax+ecx]CCamera.m_aclCams.m_fZoomFactor
		fmul	fDynamicScreenFieldOfViewScale
		mov		edx, ADDR_00514984_CCamera__00514970
		jmp		edx
	}
}

void __declspec(naked) HOOK_CCam__0051A224() {
	__asm {
		fld		[esi]CCam.m_fZoomFactor
		fmul	fDynamicScreenFieldOfViewScale
		mov		eax, ADDR_0051A22A_CCam__00519810
		jmp		eax
	}
}

void __declspec(naked) HOOK_CCam__0052198E() {
	__asm {
		fld		[esi]CCam.m_fZoomFactor
		fmul	fDynamicScreenFieldOfViewScale
		mov		eax, ADDR_00521994_CCam__00521500
		jmp		eax
	}
}

void __declspec(naked) HOOK_CPed__0056ED97() {
	__asm {
		movzx	eax, ds:[ADDR_clCamera]CCamera.m_cActiveCam
		imul	eax, 238h
		fld		ds:[ADDR_clCamera]CCamera.m_aclCams[eax].m_fZoomFactor
		fmul	fDynamicScreenFieldOfViewScale
		mov		ecx, ADDR_0056EDA1_CPed__0056EC80
		jmp		ecx
	}
}

void WINAPI InstallAllHooks() {
	static const float fBrightnessUnit = 24.0f;
	static const float fMouseSensivityScale = 0.05859375f;
	//static const float fRadarRingPlaneAngle = -0.78539816f;
	/*static const int iOnScreenTimerTime = 90000;
	static const int aiOnScreenCounterValues[4] = { 50, 100, 8, 16 };
	static const int aiOnScreenCounterMaxValues[4] = { 0, 0, 32, 0 };*/
	/*static const short sStatisticId = 0;
	static const char szMessageBoxText[400] = "Use W, S, A and D to move Carl."; // Text: +/-*/
	//static const char szSubtitleText[400] = "Come back between 9:00 and 17:00.";
	static const float fWeaponHudComponentsPosX = 143.0f;

	// Set screen Field Of View (FOV).
	InstallHookOff((LPVOID)0x00460306, setScreenFieldOfView);
	InstallHookOff((LPVOID)0x0052C977, setScreenFieldOfView);
	InstallHookOff((LPVOID)0x0053BD7B, setScreenFieldOfView);
	InstallHookOff((LPVOID)0x005BA225, setScreenFieldOfView);
	static const float fSkyMultFix = 3.1f;																	// Minimum 0.7f - Default 1.4f - Recommended 3.1f
	WriteProtectedMemory<const float *>((LPVOID)0x00714843, &fSkyMultFix);
	WriteProtectedMemory<const float *>((LPVOID)0x00714860, &fSkyMultFix);
	InstallHookJmpShort((LPVOID)0x0052C9BB, (LPVOID)0x0052C9CD);
	InstallHookJmp((LPVOID)0x0050AD4A, HOOK_CCamera__0050AD4A);
	InstallHookJmp((LPVOID)0x00510086, HOOK_CCam__00510086);
	InstallHookJmp((LPVOID)0x005102D5, HOOK_CCam__005102D5);
	InstallHookJmp((LPVOID)0x00513F28, HOOK_CCam__00513F28);
	InstallHookJmp((LPVOID)0x005143AD, HOOK_CCam__005143AD);
	InstallHookJmp((LPVOID)0x0051497D, HOOK_CCamera__0051497D);
	InstallHookJmp((LPVOID)0x0051A224, HOOK_CCam__0051A224);
	InstallHookJmp((LPVOID)0x0052198E, HOOK_CCam__0052198E);
	WriteProtectedMemory<WORD>((LPVOID)0x0051A240, LITTLE_ENDIAN_WORD(INSTR_FPTAN));
	WriteProtectedMemory<WORD>((LPVOID)0x0051A242, LITTLE_ENDIAN_WORD(INSTR_FSTP_STI + 0));
	WriteProtectedMemory<WORD>((LPVOID)0x0051A244, LITTLE_ENDIAN_WORD(INSTR_FLD_STI + 0));
	InstallHookJmpShort((LPVOID)0x0051A246, (LPVOID)0x0051A254);
	InstallHookJmp((LPVOID)0x0056ED97, HOOK_CPed__0056ED97);
	WriteProtectedMemory<WORD>((LPVOID)0x0056EDA7, LITTLE_ENDIAN_WORD(INSTR_FPTAN));
	WriteProtectedMemory<WORD>((LPVOID)0x0056EDA9, LITTLE_ENDIAN_WORD(INSTR_FSTP_STI + 0));
	WriteProtectedMemory<WORD>((LPVOID)0x0056EDAB, LITTLE_ENDIAN_WORD(INSTR_FLD_STI + 0));
	InstallHookJmpShort((LPVOID)0x0056EDAD, (LPVOID)0x0056EDB0);
	// Update screen Aspect Ratio (AR).
	InstallHookOff((LPVOID)0x0053D695, updateScreenAspectRatio);
	InstallHookOff((LPVOID)0x0053D7B2, updateScreenAspectRatio);
	InstallHookOff((LPVOID)0x0053D967, updateScreenAspectRatio);
	InstallHookOff((LPVOID)0x0053E771, updateScreenAspectRatio);
	InstallHookOff((LPVOID)0x0053EB1A, updateScreenAspectRatio);
	// Allocate video mode list.
	InstallHookJmpShort((LPVOID)0x00745B5B, (LPVOID)0x00745BCB);
	WriteProtectedMemory<BYTE>((LPVOID)0x00745BD1, INSTR_JGE_OFF8);
	WriteProtectedMemory<BYTE>((LPVOID)0x00745BD9, INSTR_JL_OFF8);
	// Print video mode list.
	WriteProtectedMemory<float *>((LPVOID)0x007459A2, &fInvScreenAspectRatioAcd);
	WriteProtectedMemory<BYTE>((LPVOID)0x007459AD, 0x41);
	WriteProtectedMemory<BYTE>((LPVOID)0x007459AE, INSTR_JP_OFF8);
	InstallHookJmpShort((LPVOID)0x007459B0, (LPVOID)0x007459E3);
	// Feature aspect ratio functions.
	WriteProtectedMemory<BYTE>(GET_PTR_AT_OFFSET(FUNC_rwD3d9System, 0x000C), 0x1B);
	InstallHookAddr(GET_PTR_AT_OFFSET(FUNC_rwD3d9System, 0x0019), alpvD3d9SystemJumpTable);
	memcpy(alpvD3d9SystemJumpTable, GET_PTR_AT_OFFSET(FUNC_rwD3d9System, 0x0AAC), sizeof(alpvD3d9SystemJumpTable));
	alpvD3d9SystemJumpTable[1] = &CODE_0_rwD3d9System;
	alpvD3d9SystemJumpTable[23] = &CODE_1_rwD3d9System;
	alpvD3d9SystemJumpTable[24] = &CODE_2_rwD3d9System;
	alpvD3d9SystemJumpTable[25] = &CODE_3_rwD3d9System;
	alpvD3d9SystemJumpTable[26] = &CODE_4_rwD3d9System;
	alpvD3d9SystemJumpTable[27] = &CODE_5_rwD3d9System;
	InstallHookJmp(GET_PTR_AT_OFFSET(FUNC_rwD3d9System, 0x04F2), HOOK_OFF_04F2_rwD3d9System);
	InstallHookJmp(GET_PTR_AT_OFFSET(FUNC_rwD3d9Release, 0x0001), HOOK_OFF_01_rwD3d9Release);
	// Rampage (Kill Frenzy) counter.
	/*InstallHookJmpShort((LPVOID)0x0043CED0, (LPVOID)0x0043CF2E);
	InstallHookJmpShort((LPVOID)0x0043D0A2, (LPVOID)0x0043D0B2);
	*VAR_piRampageTime = 90000;
	*VAR_piRampageKills = 1;*/
	WriteProtectedMemory<float *>((LPVOID)0x0043CF49, &fWideScreenHeightScaleDown);							// Text height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0043CF59, &fWideScreenWidthScaleDown);							// Text width scale.
	InstallHookJmpShort((LPVOID)0x0043CF89, (LPVOID)0x0043CF95);
	InstallHookJmp((LPVOID)0x0043CFE8, HOOK_PTR_0043CFE8_drawRampageCounter);								// Texts Y position (bad code replacement).
	WriteProtectedMemory<float *>((LPVOID)0x0043D10B, &fWideScreenWidthScaleDown);							// Time X position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0043D163, &fWideScreenWidthScaleDown);							// Kills X position scale.
	// Collectable text.
	//InstallHookJmpShort((LPVOID)0x00447791, (LPVOID)0x004477AE);
	/*strcpy(VAR_pszCollectableGxtEntry, "OY_ONE");
	*VAR_piMaxCollectables = 100;
	*VAR_piCollectables = 1;*/
	/*strcpy(VAR_pszCollectableGxtEntry, "OY_ALL");
	*VAR_piMaxCollectables = -1;
	*VAR_piCollectables = -1;*/
	WriteProtectedMemory<float *>((LPVOID)0x004477B9, &fWideScreenHeightScaleDown);							// Text height scale.
	WriteProtectedMemory<float *>((LPVOID)0x004477CF, &fWideScreenWidthScaleDown);							// Text width scale.
	WriteProtectedMemory<float *>((LPVOID)0x004477F9, &fWideScreenWidthScaleDown);							// Text centre size scale.
	WriteProtectedMemory<float *>((LPVOID)0x004478AE, &fWideScreenHeightScaleDown);							// 2-numbered text Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x00447918, &fWideScreenHeightScaleDown);							// 1-numbered text Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0044795D, &fWideScreenHeightScaleDown);							// 0-numbered text Y position scale.
	// Pickup money text.
	InstallHookJmp((LPVOID)0x0045506D, HOOK_PTR_0045506D_drawPickupMoneyText);								// Text size scale.
	// Replay text.
	/*InstallHookJmpShort((LPVOID)0x0045C211, (LPVOID)0x0045C21E);
	WriteProtectedMemory<WORD>((LPVOID)0x0045C2CA, LITTLE_ENDIAN_WORD(INSTR_ADD_ESP_IMM8));
	WriteProtectedMemory<BYTE>((LPVOID)0x0045C2CC, 0x08);
	InstallHookJmpShort((LPVOID)0x0045C2CD, (LPVOID)0x0045C2D6);*/
	WriteProtectedMemory<float *>((LPVOID)0x0045C241, &fWideScreenHeightScaleDown);							// Text height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0045C257, &fWideScreenWidthScaleDown);							// Text width scale.
	// COMMAND_DRAW_SPRITE.

	// COMMAND_DRAW_RECT.

	// COMMAND_DRAW_SPRITE_WITH_ROTATION.

	// COMMAND_DRAW_WINDOW_TEXT (when SDDWG gets updated).

	// COMMAND_CREATE_MENU.

	// COMMAND_DRAW_WINDOW.

	// COMMAND_CREATE_MENU_GRID.

	// COMMAND_SET_MENU_COLUMN_WIDTH.

	// Radio station text.
	/*InstallHookJmp((LPVOID)0x004E9E7B, (LPVOID)0x004E9E8F);
	InstallHookJmp((LPVOID)0x004E9E9C, (LPVOID)0x004E9EED);
	WriteProtectedMemory<BYTE>((LPVOID)0x004E9EED, INSTR_MOV_AL_IMM8);
	WriteProtectedMemory<BYTE>((LPVOID)0x004E9EEE, 13);*/
	WriteProtectedMemory<float *>((LPVOID)0x004E9F1C, &fWideScreenHeightScaleDown);							// Text height scale.
	WriteProtectedMemory<float *>((LPVOID)0x004E9F32, &fWideScreenWidthScaleDown);							// Text width scale.
	WriteProtectedMemory<float *>((LPVOID)0x004E9FCD, &fWideScreenHeightScaleDown);							// Text Y position scale.
	// 2D stuff.
	/*InstallHookJmpShort((LPVOID)0x0053E2BA, (LPVOID)0x0053E331);
	InstallHookJmpShort((LPVOID)0x0053E355, (LPVOID)0x0053E358);
	WriteProtectedMemory<BYTE>((LPVOID)0x0053E36C, INSTR_JMP_OFF8);
	//NopProtectedMemory((LPVOID)0x0053E36C, sizeof(WORD));*/
	WriteProtectedMemory<float *>((LPVOID)0x0053E388, &fWideScreenHeightScaleDown);							// Missile crosshair upper rectangle height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0053E3AA, &fWideScreenHeightScaleDown);							// Missile crosshair lower rectangle height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0053E3E9, &fWideScreenHeightScaleDown);							// Sniper crosshair upper rectangle height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0053E40B, &fWideScreenHeightScaleDown);							// Sniper crosshair lower rectangle height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0053E474, &fWideScreenWidthScaleDown);							// FPS crosshair left rectangle width scale.
	WriteProtectedMemory<float *>((LPVOID)0x0053E4B0, &fWideScreenWidthScaleDown);							// FPS crosshair right rectangle width scale.
	// Menu entry bars option set.
	WriteProtectedMemory<const float *>((LPVOID)0x00573487, &fBrightnessUnit);								// Balance the brightness.
	WriteProtectedMemory<const float *>((LPVOID)0x005735E6, &fMouseSensivityScale);							// Swap the old mouse sensivity with the new one.
	// Menu page set.
	InstallHookJmp((LPVOID)0x005736B6, HOOK_PTR_005736B6_CMenuManager__setPage);							// Refresh selected video ratio.
	// Menu page settings reset.
	InstallHookJmpShort((LPVOID)0x00573BD6, (LPVOID)0x00573BD9);
	InstallHookJmp((LPVOID)0x00573BDF, HOOK_PTR_00573BDF_CMenuManager__resetPageSettings);					// Reset selected video ratio.
	WriteProtectedMemory<float>((LPVOID)0x00573C10, 0.00265625f);											// Balance the mouse sensivity.
	// Menu window.
	WriteProtectedMemory<float *>((LPVOID)0x00573F7F, &fWideScreenHeightScaleDown);							// Text height scale.
	WriteProtectedMemory<float *>((LPVOID)0x00573F95, &fWideScreenWidthScaleDown);							// Text width scale.
	WriteProtectedMemory<float *>((LPVOID)0x00573FD8, &fWideScreenHeightScaleDown);							// Text Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x00573FF2, &fWideScreenWidthScaleDown);							// Text X position scale.
	// Menu message.
	/*WriteProtectedMemory<BYTE>((LPVOID)0x0053EB08, INSTR_PUSH_IMM32);
	WriteProtectedMemory<char *>((LPVOID)0x0053EB09, "FELD_WR");
	//WriteProtectedMemory<char *>((LPVOID)0x0053EB09, "FEC_ERI");
	InstallHookOff((LPVOID)0x0053EB0E, PROC_CMenuManager__drawMessage);*/
	InstallHookJmp((LPVOID)0x00574037, HOOK_PTR_00574037_CMenuManager__drawMessage);						// Text centre size.
	InstallHookJmp((LPVOID)0x00574075, HOOK_PTR_00574075_CMenuManager__drawMessage);						// Text size.
	InstallHookJmp((LPVOID)0x005740D5, HOOK_PTR_005740D5_CMenuManager__drawMessage);						// Background rectangle coordinates.
	InstallHookJmpShort((LPVOID)0x00574154, (LPVOID)0x00574158);
	InstallHookJmpShort((LPVOID)0x0057415A, (LPVOID)0x00574160);
	InstallHookJmpShort((LPVOID)0x00574166, (LPVOID)0x0057417C);
	InstallHookJmp((LPVOID)0x00574198, HOOK_PTR_00574198_CMenuManager__drawMessage);						// Text lowest Y position.
	InstallHookJmpShort((LPVOID)0x0057420C, (LPVOID)0x00574211);
	InstallHookJmp((LPVOID)0x00574213, HOOK_PTR_00574213_CMenuManager__drawMessage);						// Multiline text center Y position.
	InstallHookJmp((LPVOID)0x00574252, HOOK_PTR_00574252_CMenuManager__drawMessage);						// Monoline text center Y position.
	// Menu radio station logos.
	InstallHookJmp((LPVOID)0x005746FE, HOOK_PTR_005746FE_CMenuManager__drawRadioStationSprites);			// Set immediate float instead of integer.
	InstallHookJmp((LPVOID)0x0057471D, HOOK_PTR_0057471D_CMenuManager__drawRadioStationSprites);			// Unselected sprites rectangle coordinates.
	InstallHookJmp((LPVOID)0x005747E8, HOOK_PTR_005747E8_CMenuManager__drawRadioStationSprites);			// FPU addition rather than the integer one.
	InstallHookJmpShort((LPVOID)0x005747F4, (LPVOID)0x005747F8);
	InstallHookJmp((LPVOID)0x00574811, HOOK_PTR_00574811_CMenuManager__drawRadioStationSprites);			// Selected sprite rectangle coordinates.
	// Menu stats.
	InstallHookJmp((LPVOID)0x0057495C, HOOK_PTR_0057495C_CMenuManager__drawStats);							// Text and value size.
	InstallHookJmp((LPVOID)0x00574EB4, HOOK_PTR_00574EB4_CMenuManager__drawStats);							// Meter X position align.
	WriteProtectedMemory<float *>((LPVOID)0x00574F0E, &fWideScreenHeightScaleDown);							// Meter height scale.
	WriteProtectedMemory<float *>((LPVOID)0x00574F32, &fWideScreenWidthScaleDown);							// Meter width scale.
	InstallHookJmp((LPVOID)0x00574FD1, HOOK_PTR_00574FD1_CMenuManager__drawStats);							// Player rating text size.
	// Menu map.
	//InstallHookJmp((LPVOID)0x00575B6A, HOOK_PTR_00575B6A_CMenuManager__drawMap);							// Foreground frame stripes.
	InstallHookJmp((LPVOID)0x00575E96, HOOK_PTR_00575E96_CMenuManager__drawMap);							// Zone text size.
	InstallHookJmp((LPVOID)0x005760FD, HOOK_PTR_005760FD_CMenuManager__drawMap);							// Marker text size.
	// Menu brief.
	InstallHookJmp((LPVOID)0x00576379, HOOK_PTR_00576379_CMenuManager__drawBriefs);							// Message text size.
	InstallHookJmp((LPVOID)0x0057657C, HOOK_PTR_0057657C_CMenuManager__drawBriefs);							// Arrow up cube coordinates.
	InstallHookJmp((LPVOID)0x005766EB, HOOK_PTR_005766EB_CMenuManager__drawBriefs);							// Arrow down cube coordinates.
	// Menu entry bars.
	InstallHookJmp((LPVOID)0x00576955, HOOK_PTR_00576955_CMenuManager__drawEntryBars);						// Bar shadow rectangle coordinates.
	InstallHookJmpShort((LPVOID)0x00576A02, (LPVOID)0x00576A38);
	WriteProtectedMemory<WORD>((LPVOID)0x00576A64, LITTLE_ENDIAN_WORD(INSTR_FLD_STI + 0));
	InstallHookJmpShort((LPVOID)0x00576A66, (LPVOID)0x00576A7D);
	// Menu window with text.
	WriteProtectedMemory<WORD>((LPVOID)0x00578F63, LITTLE_ENDIAN_WORD(INSTR_FILD_PTR32));
	WriteProtectedMemory<int *>((LPVOID)0x00578F65, &CLASS_pclRsGlobal->m_iScreenWidth);
	InstallHookJmpShort((LPVOID)0x00578F69, (LPVOID)0x00578F89);
	WriteProtectedMemory<float *>((LPVOID)0x00578F8B, &fWideScreenWidthScaleDown);							// Text X wrap scale.
	WriteProtectedMemory<float *>((LPVOID)0x00578FB5, &fWideScreenWidthScaleDown);							// Text centre X wrap scale.
	WriteProtectedMemory<float *>((LPVOID)0x00578FD3, &fWideScreenWidthScaleDown);							// Text centre size scale.
	InstallHookJmp((LPVOID)0x00578FFC, HOOK_PTR_00578FFC_CMenuManager__drawWindowText);						// Text size.
	InstallHookJmp((LPVOID)0x00579081, HOOK_PTR_00579081_CMenuManager__drawWindowText);						// Background rectangle coordinates.
	InstallHookJmp((LPVOID)0x005790D4, HOOK_PTR_005790D4_CMenuManager__drawWindowText);						// Skip repetitive instructions which get executed twice.
	WriteProtectedMemory<float *>((LPVOID)0x00579140, &fWideScreenHeightScaleDown);							// Title text height scale.
	WriteProtectedMemory<float *>((LPVOID)0x00579156, &fWideScreenWidthScaleDown);							// Title text width scale.
	WriteProtectedMemory<float *>((LPVOID)0x00579199, &fWideScreenHeightScaleDown);							// Title text Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x005791B3, &fWideScreenWidthScaleDown);							// Title text X position scale.
	WriteProtectedMemory<BYTE>((LPVOID)0x005791CC, INSTR_POP_EDI);
	WriteProtectedMemory<BYTE>((LPVOID)0x005791CD, INSTR_POP_ESI);
	InstallHookJmp((LPVOID)0x005791CE, (LPVOID)0x0057931B);
	InstallHookJmp((LPVOID)0x00579316, HOOK_PTR_00579316_CMenuManager__drawWindowText);						// Return back to the title drawing.
	WriteProtectedMemory<float *>((LPVOID)0x005792FF, &fWideScreenHeightScaleDown);							// Text Y position scale.
	// Menu entries.
	InstallHookJmp((LPVOID)0x00579591, HOOK_PTR_00579591_CMenuManager__drawEntries);						// Header text size.
	InstallHookJmp((LPVOID)0x005796DA, HOOK_PTR_005796DA_CMenuManager__drawEntries);						// Description/Message text size.
	InstallHookJmp((LPVOID)0x00579936, HOOK_PTR_00579936_CMenuManager__drawEntries);						// Savegame mission text size.
	InstallHookJmp((LPVOID)0x005799B3, HOOK_PTR_005799B3_CMenuManager__drawEntries);						// Entry text size.
	InstallHookJmpShort((LPVOID)0x00579C9A, (LPVOID)0x00579CA4);
	InstallHookJmp((LPVOID)0x00579CA8, HOOK_PTR_00579CA8_CMenuManager__drawEntries);						// Arrow absolute X position.
	InstallHookJmp((LPVOID)0x0057A244, HOOK_PTR_0057A244_CMenuManager__drawEntries);						// Savegame date text size.
	InstallHookJmp((LPVOID)0x0057A2C0, HOOK_PTR_0057A2C0_CMenuManager__drawEntries);						// Radio station text size.
	InstallHookJmp((LPVOID)0x0057A32A, HOOK_PTR_0057A32A_CMenuManager__drawEntries);						// Option text size.
	InstallHookJmp((LPVOID)0x0057A45C, HOOK_PTR_0057A45C_CMenuManager__drawEntries);						// Arrow X position relative to text.
	NopProtectedMemory((LPVOID)0x0057A471, sizeof(WORD));
	WriteProtectedMemory<BYTE>((LPVOID)0x0057A489, INSTR_POP_EBX);
	InstallHookJmpShort((LPVOID)0x0057A48A, (LPVOID)0x0057A48E);
	WriteProtectedMemory<BYTE>((LPVOID)0x0057A4AF, INSTR_POP_EBX);
	InstallHookJmpShort((LPVOID)0x0057A4B0, (LPVOID)0x0057A4B6);
	NopProtectedMemory((LPVOID)0x0057A4E2, sizeof(WORD));
	WriteProtectedMemory<BYTE>((LPVOID)0x0057A4FA, INSTR_POP_EBX);
	InstallHookJmpShort((LPVOID)0x0057A4FB, (LPVOID)0x0057A4FF);
	InstallHookJmp((LPVOID)0x0057A55B, HOOK_PTR_0057A55B_CMenuManager__drawEntries);						// Arrow rectangle coordinates.
	InstallHookJmpShort((LPVOID)0x0057A7C2, (LPVOID)0x0057A7C8);
	InstallHookJmp((LPVOID)0x0057B144, HOOK_PTR_0057B144_CMenuManager__drawEntries);						// Mouse position of the left side in-between check.
	InstallHookJmp((LPVOID)0x0057B1A2, HOOK_PTR_0057B1A2_CMenuManager__drawEntries);						// Mouse position of the right side in-between check.
	InstallHookJmpShort((LPVOID)0x0057B204, (LPVOID)0x0057B20B);
	InstallHookJmp((LPVOID)0x0057B215, HOOK_PTR_0057B215_CMenuManager__drawEntries);						// Mouse position check if out of the rightmost X coordinate.
	InstallHookAddr((LPVOID)0x0057B3D0, CODE_0_CMenuManager__drawEntries);									// "Brightness" option position and size.
	InstallHookAddr((LPVOID)0x0057B3D4, CODE_1_CMenuManager__drawEntries);									// "Radio" volume option position and size.
	InstallHookAddr((LPVOID)0x0057B3D8, CODE_2_CMenuManager__drawEntries);									// "Sfx" volume option position and size.
	InstallHookAddr((LPVOID)0x0057B3DC, CODE_3_CMenuManager__drawEntries);									// "Draw Distance" option position and size.
	InstallHookAddr((LPVOID)0x0057B3E0, CODE_4_CMenuManager__drawEntries);									// "Mouse Sensivity" option position and size.
	// Menu page.
	//InstallHookJmpShort((LPVOID)0x0057BC96, (LPVOID)0x0057BCCD);
	NopProtectedMemory((LPVOID)0x0057B79C, sizeof(WORD));
	InstallHookJmp((LPVOID)0x0057B7AC, (LPVOID)0x0057B96E);
	WriteProtectedMemory<DWORD>((LPVOID)0x0057B974, LITTLE_ENDIAN_DWORD((INSTR_MOV_PTR32ESPADDOFF8_EDI << 8) | 0x14));
	WriteProtectedMemory<DWORD>((LPVOID)0x0057B978, LITTLE_ENDIAN_DWORD((INSTR_FILD_PTR32ESPADDOFF8 << 8) | 0x14));
	WriteProtectedMemory<float>((LPVOID)0x0057B9A4, 0.0f);
	WriteProtectedMemory<float>((LPVOID)0x0057B9AC, 0.0f);
	InstallHookJmpShort((LPVOID)0x0057B97C, (LPVOID)0x0057B982);
	InstallHookJmp((LPVOID)0x0057B9C0, HOOK_PTR_0057B9C0_CMenuManager__drawPage);							// Move the frontend switch statement to the appropriate position.
	InstallHookJmp((LPVOID)0x0057BCD3, HOOK_PTR_0057BCD3_CMenuManager__drawPage);							// User tracks scanning foreground rectangle coordinates (2.5f align fix).
	WriteProtectedMemory<BYTE>((LPVOID)0x0057BD54, 0x40);
	WriteProtectedMemory<BYTE>((LPVOID)0x0057BD5C, 0x4C);
	InstallHookJmp((LPVOID)0x0057BD75, HOOK_PTR_0057BD75_CMenuManager__drawPage);							// User tracks scanning square rectangle coordinates (2.5f align fix).
	WriteProtectedMemory<BYTE>((LPVOID)0x0057BE09, 0x40);
	WriteProtectedMemory<BYTE>((LPVOID)0x0057BE17, 0x4C);
	InstallHookJmp((LPVOID)0x0057C043, HOOK_PTR_0057C043_CMenuManager__drawPage);							// Map navigating cursor.
	InstallHookJmp((LPVOID)0x0057C135, HOOK_PTR_0057C135_CMenuManager__drawPage);							// Mouse cursor.
	InstallHookJmpShort((LPVOID)0x0057C19F, (LPVOID)0x0057C1A5);
	InstallHookJmp((LPVOID)0x0057C1BD, HOOK_PTR_0057C1BD_CMenuManager__drawPage);							// Cursor shadow rectangle coordinates.
	InstallHookAddr((LPVOID)0x0057C274, CODE_0_CMenuManager__drawPage);										// back2 frontend sprite rectangle coordinates.
	InstallHookAddr((LPVOID)0x0057C278, CODE_0_CMenuManager__drawPage);										// back3 frontend sprite rectangle coordinates.
	InstallHookAddr((LPVOID)0x0057C27C, CODE_0_CMenuManager__drawPage);										// back4 frontend sprite rectangle coordinates.
	InstallHookAddr((LPVOID)0x0057C280, CODE_1_CMenuManager__drawPage);										// back5 frontend sprite rectangle coordinates.
	InstallHookAddr((LPVOID)0x0057C284, CODE_0_CMenuManager__drawPage);										// back6 frontend sprite rectangle coordinates.
	InstallHookAddr((LPVOID)0x0057C288, CODE_0_CMenuManager__drawPage);										// back7 frontend sprite rectangle coordinates.
	InstallHookAddr((LPVOID)0x0057C28C, CODE_2_CMenuManager__drawPage);										// back8 frontend sprite rectangle coordinates.
	// Menu settings update.
	InstallHookAddr((LPVOID)0x0057D468, CODE_0_CMenuManager__updateEntrySetting);							// Scroll the "Radar Mode" option to left and/or right.
	InstallHookAddr((LPVOID)0x0057D480, CODE_1_CMenuManager__updateEntrySetting);							// Scroll the "Visual FX Quality" option to left and/or right.
	// Menu debugging inputs.
	InstallHookOffShort((LPVOID)0x005798B8, (LPVOID)0x005798C7);
	InstallHookJmpShort((LPVOID)0x005798BE, (LPVOID)0x005798C7);
	InstallHookJmp((LPVOID)0x0057D8E9, HOOK_PTR_0057D8E9_CMenuManager__drawDebugInputs);					// Foot/Vehicle control text height.
	InstallHookJmpShort((LPVOID)0x0057D941, (LPVOID)0x0057D948);
	WriteProtectedMemory<BYTE>((LPVOID)0x0057D98C, INSTR_FLD_PTR32ESPADDOFF8 >> 16);
	WriteProtectedMemory<BYTE>((LPVOID)0x0057DA3F, INSTR_FLD_PTR32ESPADDOFF8 >> 16);
	InstallHookJmp((LPVOID)0x0057DA79, HOOK_PTR_0057DA79_CMenuManager__drawDebugInputs);					// Increase the text Y position.
	WriteProtectedMemory<WORD>((LPVOID)0x0057DAD4, LITTLE_ENDIAN_WORD(INSTR_ADD_ESP_IMM8));
	WriteProtectedMemory<BYTE>((LPVOID)0x0057DAD6, 0x04);
	WriteProtectedMemory<DWORD>((LPVOID)0x0057DAD7, LITTLE_ENDIAN_DWORD((INSTR_FLD_PTR32ESPADDOFF8 << 8) | 0x24));
	WriteProtectedMemory<DWORD>((LPVOID)0x0057DADB, LITTLE_ENDIAN_DWORD((INSTR_FADD_PTR32ESPADDOFF8 << 8) | 0x14));
	InstallHookJmpShort((LPVOID)0x0057DADF, (LPVOID)0x0057DAE6);
	// Menu bottom message.
	InstallHookJmp((LPVOID)0x0057E250, HOOK_PTR_0057E250_CMenuManager__drawBottomMessage);					// Text size.
	// Menu inputs.
	InstallHookJmpShort((LPVOID)0x0057E6E9, (LPVOID)0x0057E715);
	NopProtectedMemory((LPVOID)0x0057E720, sizeof(WORD));
	WriteProtectedMemory<BYTE>((LPVOID)0x0057E729, 0x20);
	WriteProtectedMemory<BYTE>((LPVOID)0x0057E72D, 0x20);
	InstallHookJmp((LPVOID)0x0057E734, HOOK_PTR_0057E734_CMenuManager__drawInputs);							// Foot/Vehicle control text height.
	WriteProtectedMemory<DWORD>((LPVOID)0x0057E789, LITTLE_ENDIAN_DWORD((INSTR_MOV_EBP_PTR32ESPADDOFF8 << 8) | 0x1C));
	InstallHookJmpShort((LPVOID)0x0057E78D, (LPVOID)0x0057E7A0);
	InstallHookJmp((LPVOID)0x0057EA24, HOOK_PTR_0057EA24_CMenuManager__drawInputs);							// Selection Y position.
	WriteProtectedMemory<DWORD>((LPVOID)0x0057EAB7, LITTLE_ENDIAN_DWORD((INSTR_LEA_ECX_PTR32ESPADDOFF8 << 8) | 0x48));
	InstallHookJmpShort((LPVOID)0x0057EAC0, (LPVOID)0x0057EACC);
	InstallHookJmp((LPVOID)0x0057EB0E, HOOK_PTR_0057EB0E_CMenuManager__drawInputs);							// Text size.
	WriteProtectedMemory<BYTE>((LPVOID)0x0057EB9C, INSTR_FLD_PTR32ESPADDOFF8 >> 16);
	WriteProtectedMemory<BYTE>((LPVOID)0x0057EC87, INSTR_FLD_PTR32ESPADDOFF8 >> 16);
	WriteProtectedMemory<BYTE>((LPVOID)0x0057ED40, INSTR_FLD_PTR32ESPADDOFF8 >> 16);
	InstallHookJmp((LPVOID)0x0057EDB9, HOOK_PTR_0057EDB9_CMenuManager__drawInputs);							// Initialize the next step of the text drawing loop.
	// Menu page no entries processing.
	InstallHookJmp((LPVOID)0x0057EFE8, HOOK_PTR_0057EFE8_CMenuManager__processController);					// Return back after pressing "Enter" on "Back".
	WriteProtectedMemory<BYTE>((LPVOID)0x0057F118, INSTR_JNS_OFF8);
	WriteProtectedMemory<BYTE>((LPVOID)0x0057F126, INSTR_JL_OFF8);
	InstallHookJmp((LPVOID)0x0057F235, HOOK_PTR_0057F235_CMenuManager__processController);					// Submit mouse inputs only when visible.
	NopProtectedMemory((LPVOID)0x0057F241, 3);
	InstallHookJmp((LPVOID)0x0057F2A3, HOOK_PTR_0057F2A3_CMenuManager__processController);					// Play the frontend sound when moving up or down.
	WriteProtectedMemory<int>((LPVOID)0x0057F1D8, -1);
	// Menu controls page.
	InstallHookJmp((LPVOID)0x0057F693, HOOK_PTR_0057F693_CMenuManager__drawControls);						// Header text size.
	InstallHookJmp((LPVOID)0x0057F794, HOOK_PTR_0057F794_CMenuManager__drawControls);						// Foot control text height.
	InstallHookJmp((LPVOID)0x0057F7DB, HOOK_PTR_0057F7DB_CMenuManager__drawControls);						// Vehicle control text height.
	WriteProtectedMemory<WORD>((LPVOID)0x0057F87C, LITTLE_ENDIAN_WORD(INSTR_ADD_ESP_IMM8));
	WriteProtectedMemory<BYTE>((LPVOID)0x0057F87E, 0x08);
	WriteProtectedMemory<DWORD>((LPVOID)0x0057F87F, LITTLE_ENDIAN_DWORD((INSTR_MOV_PTR8ESPADDOFF8_IMM8 << 8) | 0x0F));
	WriteProtectedMemory<BYTE>((LPVOID)0x0057F883, 0x00);
	InstallHookJmpShort((LPVOID)0x0057F884, (LPVOID)0x0057F8B1);
	WriteProtectedMemory<BYTE>((LPVOID)0x0057F863, 0x20);
	WriteProtectedMemory<BYTE>((LPVOID)0x0057F8B4, 0x18);
	InstallHookJmp((LPVOID)0x0057F8C2, HOOK_PTR_0057F8C2_CMenuManager__drawControls);						// Add cursor-shown check.
	InstallHookOff((LPVOID)0x0057F8F1, (LPVOID)0x0057F9AF);
	InstallHookOff((LPVOID)0x0057F916, (LPVOID)0x0057F9AF);
	WriteProtectedMemory<float>((LPVOID)0x0057F8FC, 620.0f);
	InstallHookJmp((LPVOID)0x0057F91A, HOOK_PTR_0057F91A_CMenuManager__drawControls);						// Mouse on or after/before the uppermost/lowermost of the input selection.
	InstallHookJmpShort((LPVOID)0x0057F993, (LPVOID)0x0057F999);
	WriteProtectedMemory<BYTE>((LPVOID)0x0057F9FC, 0x2C);
	WriteProtectedMemory<BYTE>((LPVOID)0x0057FA0A, 0x2C);
	InstallHookJmp((LPVOID)0x0057FA18, HOOK_PTR_0057FA18_CMenuManager__drawControls);						// Control text size.
	InstallHookJmpShort((LPVOID)0x0057FA4A, (LPVOID)0x0057FA56);
	WriteProtectedMemory<BYTE>((LPVOID)0x0057FA56, INSTR_FILD_PTR32 >> 8);
	InstallHookJmp((LPVOID)0x0057FA6F, HOOK_PTR_0057FA6F_CMenuManager__drawControls);						// Control text position.
	WriteProtectedMemory<BYTE>((LPVOID)0x0057FAE9, 0x24);
	InstallHookJmp((LPVOID)0x0057FAF3, HOOK_PTR_0057FAF3_CMenuManager__drawControls);						// Mouse on or after/before the uppermost/lowermost of Back.
	WriteProtectedMemory<float>((LPVOID)0x0057FC42, 620.0f);
	InstallHookJmp((LPVOID)0x0057FCCC, HOOK_PTR_0057FCCC_CMenuManager__drawControls);						// Back text size.
	InstallHookJmpShort((LPVOID)0x0057FD02, (LPVOID)0x0057FD0D);
	// Menu.
	WriteProtectedMemory<float *>((LPVOID)0x00580E13, &fWideScreenHeightScaleDown);							// Overall Y position and height scale.
	WriteProtectedMemory<float *>((LPVOID)0x00580F18, &fWideScreenWidthScaleDown);							// Menu width scale.
	WriteProtectedMemory<float *>((LPVOID)0x00580F87, &fWideScreenHeightScaleDown);							// Disabled row text height scale.
	WriteProtectedMemory<float *>((LPVOID)0x00580F97, &fWideScreenWidthScaleDown);							// Disabled row text width scale.
	WriteProtectedMemory<float *>((LPVOID)0x00581134, &fWideScreenHeightScaleDown);							// Disabled row right-aligned Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058115A, &fWideScreenWidthScaleDown);							// Disabled row right-aligned X position scale.
	WriteProtectedMemory<float *>((LPVOID)0x005810CE, &fWideScreenHeightScaleDown);							// Disabled row left-aligned Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x005810F1, &fWideScreenWidthScaleDown);							// Disabled row left-aligned X position scale.
	WriteProtectedMemory<float *>((LPVOID)0x005811A3, &fWideScreenHeightScaleDown);							// Disabled row centered Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x005811CF, &fWideScreenWidthScaleDown);							// Disabled row centered X position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058147C, &fWideScreenHeightScaleDown);							// Enabled row text height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058148C, &fWideScreenWidthScaleDown);							// Enabled row text width scale.
	WriteProtectedMemory<float *>((LPVOID)0x005814E9, &fWideScreenHeightScaleDown);							// Enabled row text height scale relative to the column with.
	WriteProtectedMemory<float *>((LPVOID)0x005814F9, &fWideScreenWidthScaleDown);							// Enabled row text width scale relative to the column with.
	WriteProtectedMemory<float *>((LPVOID)0x005815B3, &fWideScreenWidthScaleDown);							// Enabled row left-aligned X position scale.
	WriteProtectedMemory<float *>((LPVOID)0x005815ED, &fWideScreenWidthScaleDown);							// Enabled row right-aligned X position scale.
	WriteProtectedMemory<float *>((LPVOID)0x00581635, &fWideScreenWidthScaleDown);							// Enabled row centered X position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058169B, &fWideScreenHeightScaleDown);							// Incrementing Y position scale.
	// Menu grid.
	WriteProtectedMemory<float *>((LPVOID)0x0058188B, &fWideScreenHeightScaleDown);							// Colored square height scale.
	WriteProtectedMemory<float *>((LPVOID)0x005818D1, &fWideScreenWidthScaleDown);							// Colored square width scale.
	// Map legend.
	WriteProtectedMemory<float *>((LPVOID)0x00582EB2, &fWideScreenWidthScaleDown);							// Squared radar blip border width scale.
	WriteProtectedMemory<float *>((LPVOID)0x00582ED5, &fWideScreenHeightScaleDown);							// Squared radar blip border height scale.
	WriteProtectedMemory<float *>((LPVOID)0x00582FF7, &fWideScreenHeightScaleDown);							// Fipped triangular radar blip border height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058301B, &fWideScreenWidthScaleDown);							// Fipped triangular radar blip border width scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058307B, &fWideScreenHeightScaleDown);							// Fipped triangular radar blip height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058309E, &fWideScreenWidthScaleDown);							// Fipped triangular radar blip width scale.
	WriteProtectedMemory<float *>((LPVOID)0x00582F84, &fWideScreenWidthScaleDown);							// Squared radar blip width scale.
	WriteProtectedMemory<float *>((LPVOID)0x00582FA5, &fWideScreenHeightScaleDown);							// Squared radar blip height scale.
	WriteProtectedMemory<float *>((LPVOID)0x005830F8, &fWideScreenHeightScaleDown);							// Triangular radar blip border height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058312A, &fWideScreenWidthScaleDown);							// Triangular radar blip border width scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058317D, &fWideScreenHeightScaleDown);							// Triangular radar blip height scale.
	WriteProtectedMemory<float *>((LPVOID)0x005831AF, &fWideScreenWidthScaleDown);							// Triangular radar blip width scale.
	WriteProtectedMemory<float *>((LPVOID)0x00582DFC, (float *)&CLASS_pclRsGlobal->m_iScreenHeight);		// Swap the screen width with the screen height.
	WriteProtectedMemory<float *>((LPVOID)0x00582E0F, &fWideScreenHeightScaleDown);							// Radar sprite height scale.
	InstallHookJmp((LPVOID)0x00582E21, HOOK_PTR_00582E21_CMenuManager__drawMapLegend);						// Radar sprite width scale.
	WriteProtectedMemory<WORD>((LPVOID)0x00582E34, LITTLE_ENDIAN_WORD(INSTR_FADDP_STI_ST0 + 1));
	// Radar map zoomed coordinates.
	WriteProtectedMemory<float *>((LPVOID)0x005834BC, &fWideScreenWidthScaleDown);							// Map width scale.
	WriteProtectedMemory<float *>((LPVOID)0x005834EE, &fWideScreenHeightScaleDown);							// Map height scale.
	// Radar blip.
	WriteProtectedMemory<float *>((LPVOID)0x0058410D, &fWideScreenWidthScaleDown);							// Squared radar blip border width scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058412D, &fWideScreenHeightScaleDown);							// Squared radar blip border height scale.
	WriteProtectedMemory<float *>((LPVOID)0x00584192, &fWideScreenWidthScaleDown);							// Squared radar blip width scale.
	WriteProtectedMemory<float *>((LPVOID)0x005841B2, &fWideScreenHeightScaleDown);							// Squared radar blip height scale.
	WriteProtectedMemory<float *>((LPVOID)0x00584209, &fWideScreenHeightScaleDown);							// Fipped triangular radar blip border height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058424B, &fWideScreenWidthScaleDown);							// Fipped triangular radar blip border width scale.
	WriteProtectedMemory<float *>((LPVOID)0x005842C8, &fWideScreenHeightScaleDown);							// Fipped triangular radar blip height scale.
	WriteProtectedMemory<float *>((LPVOID)0x005842E8, &fWideScreenWidthScaleDown);							// Fipped triangular radar blip width scale.
	WriteProtectedMemory<float *>((LPVOID)0x00584348, &fWideScreenHeightScaleDown);							// Triangular radar blip border height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058439E, &fWideScreenWidthScaleDown);							// Triangular radar blip border width scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058440E, &fWideScreenHeightScaleDown);							// Triangular radar blip height scale.
	WriteProtectedMemory<float *>((LPVOID)0x00584436, &fWideScreenWidthScaleDown);							// Triangular radar blip width scale.
	// Radar position.
	WriteProtectedMemory<float *>((LPVOID)0x005849FC, &fWideScreenHeightScaleDown);							// Sprite height scale.
	WriteProtectedMemory<float *>((LPVOID)0x00584A14, &fWideScreenWidthScaleDown);							// Sprite width scale.
	// Radar sprite.
	WriteProtectedMemory<float *>((LPVOID)0x00586041, &fWideScreenWidthScaleDown);							// Sprite width scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058605A, &fWideScreenHeightScaleDown);							// Sprite height scale.
	// Radar blip for entity.
	WriteProtectedMemory<float *>((LPVOID)0x005876BE, &fWideScreenHeightScaleDown);							// Radar centre sprite height scale.
	WriteProtectedMemory<float *>((LPVOID)0x005876D6, &fWideScreenWidthScaleDown);							// Radar centre sprite width scale.
	WriteProtectedMemory<float *>((LPVOID)0x00587735, &fWideScreenHeightScaleDown);							// Radar centre sprite height scale on camera locked behind the player.
	WriteProtectedMemory<float *>((LPVOID)0x0058774D, &fWideScreenWidthScaleDown);							// Radar centre sprite width scale on camera locked behind the player.
	WriteProtectedMemory<float *>((LPVOID)0x0058780C, &fWideScreenWidthScaleDown);							// Radar searchlight sprite X position scale.
	WriteProtectedMemory<float *>((LPVOID)0x00587891, &fWideScreenWidthScaleDown);							// Radar searchlight sprite width scale.
	WriteProtectedMemory<float *>((LPVOID)0x00587918, &fWideScreenHeightScaleDown);							// Radar moving light sprite height scale.
	WriteProtectedMemory<float *>((LPVOID)0x00587930, &fWideScreenWidthScaleDown);							// Radar moving light sprite width scale.
	WriteProtectedMemory<float *>((LPVOID)0x00587A04, &fWideScreenHeightScaleDown);							// Radar runway lights sprite height scale in menu.
	WriteProtectedMemory<float *>((LPVOID)0x00587A1C, &fWideScreenWidthScaleDown);							// Radar runway lights sprite width scale in menu.
	WriteProtectedMemory<float *>((LPVOID)0x00587A94, &fWideScreenHeightScaleDown);							// Radar runway lights sprite height scale.
	WriteProtectedMemory<float *>((LPVOID)0x00587AAC, &fWideScreenWidthScaleDown);							// Radar runway lights sprite width scale.
	// Radar blips (including fix of menu map boundaries clamping).
	InstallHookJmp((LPVOID)0x00588223, HOOK_PTR_00588223_drawBlips);										// Map boundaries scale.
	InstallHookJmpShort((LPVOID)0x00588232, (LPVOID)0x00588238);
	InstallHookJmpShort((LPVOID)0x0058823D, (LPVOID)0x00588243);
	WriteProtectedMemory<WORD>((LPVOID)0x0058824D, LITTLE_ENDIAN_WORD(INSTR_FLD_PTR32ESPADDOFF8 >> 8));
	InstallHookJmpShort((LPVOID)0x00588289, (LPVOID)0x0058828F);
	InstallHookJmpShort((LPVOID)0x00588294, (LPVOID)0x0058829A);
	WriteProtectedMemory<WORD>((LPVOID)0x005882A4, LITTLE_ENDIAN_WORD(INSTR_FLD_PTR32ESPADDOFF8 >> 8));
	InstallHookJmp((LPVOID)0x005886B9, HOOK_PTR_005886B9_drawBlips);										// Radar centre sprite size.
	WriteProtectedMemory<BYTE>((LPVOID)0x00588712, INSTR_PUSH_EBP);
	// HUD component Y position computation.
	WriteProtectedMemory<float *>((LPVOID)0x00588B9E, &fWideScreenHeightScaleDown);							// Component relative Y position scale.
	// Armour meter.
	WriteProtectedMemory<float *>((LPVOID)0x00589140, &fWideScreenHeightScaleDown);							// Meter height scale.
	WriteProtectedMemory<float *>((LPVOID)0x00589157, &fWideScreenWidthScaleDown);							// Meter width scale.
	// Breath meter.
	WriteProtectedMemory<float *>((LPVOID)0x00589218, &fWideScreenHeightScaleDown);							// Meter height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058922F, &fWideScreenWidthScaleDown);							// Meter width scale.
	// Health meter.
	WriteProtectedMemory<float *>((LPVOID)0x005892CC, &fWideScreenWidthScaleDown);							// Meter width scale.
	WriteProtectedMemory<float *>((LPVOID)0x00589348, &fWideScreenHeightScaleDown);							// Meter height scale.
	WriteProtectedMemory<float *>((LPVOID)0x00589380, &fWideScreenWidthScaleDown);							// Meter X position scale.
	// Weapon ammo.
	WriteProtectedMemory<float *>((LPVOID)0x005894B1, &fWideScreenHeightScaleDown);							// Text height scale.
	WriteProtectedMemory<float *>((LPVOID)0x005894C7, &fWideScreenWidthScaleDown);							// Text width scale.
	InstallHookJmpShort((LPVOID)0x005894E9, (LPVOID)0x005894F5);
	// Statistics.
	InstallHookJmpShort((LPVOID)0x005896D8, (LPVOID)0x005896E4);
	WriteProtectedMemory<float *>((LPVOID)0x00589705, &fWideScreenWidthScaleDown);							// Texts and meters X position scale.
	InstallHookJmp((LPVOID)0x00589709, HOOK_PTR_00589709_drawStatistics);									// Box content X positions.
	WriteProtectedMemory<float *>((LPVOID)0x00589737, &fWideScreenHeightScaleDown);							// Respect meter relative Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058978D, &fWideScreenHeightScaleDown);							// 5-meters box height scale.
	InstallHookJmpShort((LPVOID)0x005897A3, (LPVOID)0x005897AB);
	WriteProtectedMemory<float *>((LPVOID)0x005897C5, &fWideScreenWidthScaleDown);							// 5-meters box width scale.
	WriteProtectedMemory<DWORD>((LPVOID)0x005897CF, LITTLE_ENDIAN_DWORD((INSTR_FADD_PTR32ESPADDOFF8 << 8) | 0x38));
	NopProtectedMemory((LPVOID)0x005897D3, sizeof(WORD));
	WriteProtectedMemory<float *>((LPVOID)0x00589815, &fWideScreenHeightScaleDown);							// 5-meters box content relative Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x00589841, &fWideScreenHeightScaleDown);							// 6-meters box height scale.
	InstallHookJmpShort((LPVOID)0x00589857, (LPVOID)0x0058985F);
	WriteProtectedMemory<float *>((LPVOID)0x0058986F, &fWideScreenWidthScaleDown);							// 6-meters box width scale.
	WriteProtectedMemory<DWORD>((LPVOID)0x00589879, LITTLE_ENDIAN_DWORD((INSTR_FADD_PTR32ESPADDOFF8 << 8) | 0x38));
	NopProtectedMemory((LPVOID)0x0058987D, sizeof(WORD));
	WriteProtectedMemory<float *>((LPVOID)0x005898BF, &fWideScreenHeightScaleDown);							// 6-meters box content relative Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x005898F8, &fWideScreenHeightScaleDown);							// Skill text height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058990E, &fWideScreenWidthScaleDown);							// Skill text width scale.
	WriteProtectedMemory<float *>((LPVOID)0x00589A01, &fWideScreenHeightScaleDown);							// Respect text and meter height scale.
	WriteProtectedMemory<float *>((LPVOID)0x00589A18, &fWideScreenWidthScaleDown);							// Respect text and meter width scale.
	WriteProtectedMemory<float *>((LPVOID)0x00589A01, &fWideScreenHeightScaleDown);							// Lung capacity/Weapon skill text and meter relative Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x00589B18, &fWideScreenHeightScaleDown);							// Lung capacity text and meter height scale.
	WriteProtectedMemory<float *>((LPVOID)0x00589B2F, &fWideScreenWidthScaleDown);							// Lung capacity text and meter width scale.
	WriteProtectedMemory<float *>((LPVOID)0x00589C5E, &fWideScreenHeightScaleDown);							// Weapon skill text and meter height scale.
	WriteProtectedMemory<float *>((LPVOID)0x00589C75, &fWideScreenWidthScaleDown);							// Weapon skill text and meter width scale.
	WriteProtectedMemory<float *>((LPVOID)0x00589CAA, &fWideScreenHeightScaleDown);							// Stamina text and meter relative Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x00589D4C, &fWideScreenHeightScaleDown);							// Stamina text and meter height scale.
	WriteProtectedMemory<float *>((LPVOID)0x00589D63, &fWideScreenWidthScaleDown);							// Stamina text and meter width scale.
	WriteProtectedMemory<float *>((LPVOID)0x00589D94, &fWideScreenHeightScaleDown);							// Muscle text and meter relative Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x00589E34, &fWideScreenHeightScaleDown);							// Muscle text and meter height scale.
	WriteProtectedMemory<float *>((LPVOID)0x00589E4B, &fWideScreenWidthScaleDown);							// Muscle text and meter width scale.
	WriteProtectedMemory<float *>((LPVOID)0x00589E7C, &fWideScreenHeightScaleDown);							// Fat text and meter relative Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x00589F1C, &fWideScreenHeightScaleDown);							// Fat text and meter height scale.
	WriteProtectedMemory<float *>((LPVOID)0x00589F33, &fWideScreenWidthScaleDown);							// Fat text and meter width scale.
	WriteProtectedMemory<float *>((LPVOID)0x00589F64, &fWideScreenHeightScaleDown);							// Sex appeal text and meter relative Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x00589FFE, &fWideScreenHeightScaleDown);							// Sex appeal text and meter height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058A015, &fWideScreenWidthScaleDown);							// Sex appeal text and meter width scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058A042, &fWideScreenHeightScaleDown);							// Weekday text relative Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058A07C, &fWideScreenHeightScaleDown);							// Weekday text height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058A092, &fWideScreenWidthScaleDown);							// Weekday text width scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058A136, &fWideScreenWidthScaleDown);							// Weekday text X position scale.
	WriteProtectedMemory<DWORD>((LPVOID)0x0058A140, LITTLE_ENDIAN_DWORD((INSTR_FADD_PTR32ESPADDOFF8 << 8) | 0x34));
	NopProtectedMemory((LPVOID)0x0058A144, sizeof(WORD));
	// Trip skip.
	/*InstallHookJmpShort((LPVOID)0x0058FC58, (LPVOID)0x0058FC61);
	InstallHookOffShort((LPVOID)0x0058FC69, (LPVOID)0x0058FCA6);
	InstallHookJmpShort((LPVOID)0x0058FC6F, (LPVOID)0x0058FCA6);*/
	WriteProtectedMemory<float *>((LPVOID)0x0058A17A, &fWideScreenWidthScaleDown);							// Sprite X position and width scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058A19B, &fWideScreenHeightScaleDown);							// Sprite Y position and height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058A209, &fWideScreenHeightScaleDown);							// Text height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058A21F, &fWideScreenWidthScaleDown);							// Text width scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058A2B2, &fWideScreenHeightScaleDown);							// Text Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058A2C2, &fWideScreenWidthScaleDown);							// Text X position scale.
	// Map.
	/*WriteProtectedMemory<WORD>((LPVOID)0x0058A39C, LITTLE_ENDIAN_WORD(INSTR_FLD_PTR_32));
	WriteProtectedMemory<const float *>((LPVOID)0x0058A39E, &fRadarRingPlaneAngle);
	WriteProtectedMemory<WORD>((LPVOID)0x0058A3A2, LITTLE_ENDIAN_WORD(INSTR_XOR_EAX_EAX));
	WriteProtectedMemory<DWORD>((LPVOID)0x0058A3A4, LITTLE_ENDIAN_DWORD((INSTR_MOV_ESP_8_EAX << 8) | 0x04));
	InstallHookJmp((LPVOID)0x0058A3A8, (LPVOID)0x0058A43B);
	InstallHookJmpShort((LPVOID)0x0058A556, (LPVOID)0x0058A5CC);*/
	WriteProtectedMemory<float *>((LPVOID)0x0058A443, &fWideScreenWidthScaleDown);							// Radar ring plane sprite X position and width scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058A475, &fWideScreenHeightScaleDown);							// Radar ring plane sprite Y position and height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058A5DA, &fWideScreenWidthScaleDown);							// Altimeter vertical bar X position and width scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058A602, &fWideScreenHeightScaleDown);							// Altimeter vertical bar Y position and height scale.
	InstallHookJmp((LPVOID)0x0058A68F, HOOK_PTR_0058A68F_drawMap);											// Altimeter horizontal bar position and scale.
	WriteProtectedMemory<DWORD>((LPVOID)0x0058A745, LITTLE_ENDIAN_DWORD((INSTR_FSTP_PTR32ESPADDOFF8 << 8) | 0x1C));
	WriteProtectedMemory<DWORD>((LPVOID)0x0058A74E, LITTLE_ENDIAN_DWORD((INSTR_FSTP_PTR32ESPADDOFF8 << 8) | 0x28));
	InstallHookJmpShort((LPVOID)0x0058A757, (LPVOID)0x0058A75D);
	InstallHookJmpShort((LPVOID)0x0058A761, (LPVOID)0x0058A76F);
	WriteProtectedMemory<float *>((LPVOID)0x0058A793, &fWideScreenWidthScaleDown);							// Upper-left radar disc X position and width scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058A7BB, &fWideScreenHeightScaleDown);							// Upper-left radar disc Y position and height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058A830, &fWideScreenWidthScaleDown);							// Upper-right radar disc X position and width scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058A85C, &fWideScreenHeightScaleDown);							// Upper-right radar disc Y position and height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058A8E1, &fWideScreenWidthScaleDown);							// Lower-left radar disc X position and width scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058A90B, &fWideScreenHeightScaleDown);							// Lower-left radar disc Y position and height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058A984, &fWideScreenWidthScaleDown);							// Lower-right radar disc X position and width scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058A9BF, &fWideScreenHeightScaleDown);							// Lower-right radar disc Y position and height scale.
	// Zone name.
	/*InstallHookJmpShort((LPVOID)0x0058AA51, (LPVOID)0x0058AA57);
	InstallHookJmpShort((LPVOID)0x0058AA5A, (LPVOID)0x0058AA62);
	WriteProtectedMemory<BYTE>((LPVOID)0x0058AA69, INSTR_MOV_EBP_IMM32);
	WriteProtectedMemory<int>((LPVOID)0x0058AA6A, 3);
	InstallHookJmp((LPVOID)0x0058AA6E, (LPVOID)0x0058AAF3);
	InstallHookOff((LPVOID)0x0058AAFF, (LPVOID)0x0058AABB);
	InstallHookJmpShort((LPVOID)0x0058AAC1, (LPVOID)0x0058AB13);
	*VAR_ppszZoneName = "Ganton";*/
	WriteProtectedMemory<float *>((LPVOID)0x0058AD26, &fWideScreenHeightScaleDown);							// Text height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058AD3C, &fWideScreenWidthScaleDown);							// Text width scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058AD67, &fWideScreenWidthScaleDown);							// Text centre X wrap scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058AE0F, &fWideScreenHeightScaleDown);							// Text Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058AE4C, &fWideScreenWidthScaleDown);							// Text X position scale.
	// Vehicle name.
	/*InstallHookJmpShort((LPVOID)0x0058897E, (LPVOID)0x00588984);
	InstallHookJmpShort((LPVOID)0x00588ADA, (LPVOID)0x00588AE0);
	InstallHookJmpShort((LPVOID)0x0058AEA1, (LPVOID)0x0058AEA7);
	InstallHookJmpShort((LPVOID)0x0058AEAA, (LPVOID)0x0058AEC9);
	WriteProtectedMemory<BYTE>((LPVOID)0x0058AED0, INSTR_MOV_EBX_IMM32);
	WriteProtectedMemory<int>((LPVOID)0x0058AED1, 3);
	InstallHookJmpShort((LPVOID)0x0058AED5, (LPVOID)0x0058AF35);
	InstallHookOff((LPVOID)0x0058AF39, (LPVOID)0x0058AEF4);
	InstallHookOffShort((LPVOID)0x0058AEFB, (LPVOID)0x0058AF4D);
	*VAR_ppszVehicleName = "Landstalker";*/
	WriteProtectedMemory<float *>((LPVOID)0x0058B08B, &fWideScreenHeightScaleDown);							// Text height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058B0A1, &fWideScreenWidthScaleDown);							// Text width scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058B12F, &fWideScreenHeightScaleDown);							// Text Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058B141, &fWideScreenWidthScaleDown);							// Text X position scale.
	// On-screen displays.
	/*InstallHookJmpShort((LPVOID)0x00571EE0, (LPVOID)0x00571EE5);
	InstallHookJmpShort((LPVOID)0x00571EF8, (LPVOID)0x00571EFD);
	*VAR_pbShowOnScreenDisplays = true;
	*VAR_pbFreezeTimer = false;
	CLASS_pclOnScreenTimer->m_bEnable = true;
	CLASS_pclOnScreenTimer->m_bShow = true;
	strcpy(CLASS_pclOnScreenTimer->m_szGxtEntry, "BB_19");
	CLASS_pclOnScreenTimer->m_iScriptVarValue = DMA_SCRIPT_BUFFER(&iOnScreenTimerTime);
	CLASS_pclOnScreenTimer->m_iSecsToPlaySound = 10;
	(*CLASS_pclOnScreenCounters)[0].m_sType = COUNTER_DISPLAY_BAR;
	(*CLASS_pclOnScreenCounters)[0].m_bShow = true;
	(*CLASS_pclOnScreenCounters)[0].m_bFlashOnShow = false;
	(*CLASS_pclOnScreenCounters)[0].m_cBaseColor = 3;
	strcpy((*CLASS_pclOnScreenCounters)[0].m_szGxtEntry, "LOWR1");
	(*CLASS_pclOnScreenCounters)[0].m_iScriptVarValue = DMA_SCRIPT_BUFFER(&aiOnScreenCounterValues[0]);
	(*CLASS_pclOnScreenCounters)[1].m_sType = COUNTER_DISPLAY_BAR;
	(*CLASS_pclOnScreenCounters)[1].m_bShow = true;
	(*CLASS_pclOnScreenCounters)[1].m_bFlashOnShow = true;
	(*CLASS_pclOnScreenCounters)[1].m_cBaseColor = 3;
	strcpy((*CLASS_pclOnScreenCounters)[1].m_szGxtEntry, "LOWR2");
	(*CLASS_pclOnScreenCounters)[1].m_iScriptVarValue = DMA_SCRIPT_BUFFER(&aiOnScreenCounterValues[1]);
	(*CLASS_pclOnScreenCounters)[2].m_sType = COUNTER_DISPLAY_INTERVAL;
	(*CLASS_pclOnScreenCounters)[2].m_bShow = true;
	(*CLASS_pclOnScreenCounters)[2].m_bFlashOnShow = false;
	(*CLASS_pclOnScreenCounters)[2].m_cBaseColor = 3;
	strcpy((*CLASS_pclOnScreenCounters)[2].m_szGxtEntry, "BB_18");
	(*CLASS_pclOnScreenCounters)[2].m_iScriptVarValue = DMA_SCRIPT_BUFFER(&aiOnScreenCounterValues[2]);
	(*CLASS_pclOnScreenCounters)[2].m_iScriptVarMaxValue = DMA_SCRIPT_BUFFER(&aiOnScreenCounterMaxValues[2]);
	(*CLASS_pclOnScreenCounters)[3].m_sType = COUNTER_DISPLAY_NUMBER;
	(*CLASS_pclOnScreenCounters)[3].m_bShow = true;
	(*CLASS_pclOnScreenCounters)[3].m_bFlashOnShow = true;
	(*CLASS_pclOnScreenCounters)[3].m_cBaseColor = 3;
	strcpy((*CLASS_pclOnScreenCounters)[3].m_szGxtEntry, "BB_14");
	(*CLASS_pclOnScreenCounters)[3].m_iScriptVarValue = DMA_SCRIPT_BUFFER(&aiOnScreenCounterValues[3]);*/
	WriteProtectedMemory<BYTE>((LPVOID)0x0058B1B0, INSTR_PUSH_ESI);
	WriteProtectedMemory<BYTE>((LPVOID)0x0058B1B1, INSTR_PUSH_EDI);
	WriteProtectedMemory<WORD>((LPVOID)0x0058B1B2, LITTLE_ENDIAN_WORD(INSTR_XOR_EDI_EDI));
	InstallHookJmp((LPVOID)0x0058B1B4, HOOK_PTR_0058B1B4_drawOnScreenDisplays);								// Texts Y position (bad code replacement).
	WriteProtectedMemory<float *>((LPVOID)0x0058B265, &fWideScreenHeightScaleDown);							// Texts height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058B275, &fWideScreenWidthScaleDown);							// Texts width scale.
	InstallHookJmpShort((LPVOID)0x0058B2A4, (LPVOID)0x0058B2B0);
	WriteProtectedMemory<float *>((LPVOID)0x0058B3B1, &fWideScreenWidthScaleDown);							// Timer text X position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058B3FE, &fWideScreenWidthScaleDown);							// Timer value text X position scale.
	WriteProtectedMemory<DWORD>((LPVOID)0x0058B42A, LITTLE_ENDIAN_DWORD((INSTR_FLD_PTR32ESPADDOFF8 << 8) | 0x14));
	WriteProtectedMemory<DWORD>((LPVOID)0x0058B42E, LITTLE_ENDIAN_DWORD((INSTR_FSTP_PTR32ESPADDOFF8 << 8) | 0x10));
	InstallHookJmpShort((LPVOID)0x0058B432, (LPVOID)0x0058B49D);
	WriteProtectedMemory<float *>((LPVOID)0x0058B538, &fWideScreenHeightScaleDown);							// Counter relative Y position.
	WriteProtectedMemory<float *>((LPVOID)0x0058B56C, &fWideScreenWidthScaleDown);							// Counter value text X position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058B5E0, &fWideScreenHeightScaleDown);							// Counter meter relative Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058B5F0, &fWideScreenWidthScaleDown);							// Counter meter X position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058B680, &fWideScreenWidthScaleDown);							// Counter text X position scale.
	// Message box.
	/*InstallHookJmpShort((LPVOID)0x0058B6E0, (LPVOID)0x0058B6E5);
	NopProtectedMemory((LPVOID)0x0058B6E8, sizeof(WORD));
	InstallHookJmpShort((LPVOID)0x0058B6EE, (LPVOID)0x0058B70D);
	InstallHookJmp((LPVOID)0x0058B717, (LPVOID)0x0058B84D);
	InstallHookOff((LPVOID)0x0058B860, (LPVOID)0x0058B731);
	WriteProtectedMemory<const char *>((LPVOID)0x0058B739, szMessageBoxText);
	InstallHookJmpShort((LPVOID)0x0058B742, (LPVOID)0x0058B74E);
	WriteProtectedMemory<int *>((LPVOID)0x0058B750, VAR_piMessageBoxShownTime);
	InstallHookOffShort((LPVOID)0x0058B825, (LPVOID)0x0058B875);
	WriteProtectedMemory<const short *>((LPVOID)0x0058BA78, &sStatisticId);
	WriteProtectedMemory<const short *>((LPVOID)0x0058BD7F, &sStatisticId);*/
	WriteProtectedMemory<float *>((LPVOID)0x0058B771, &fWideScreenWidthScaleDown);							// Text X wrap scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058B7BF, &fWideScreenHeightScaleDown);							// Text Y position scale for the line count.
	WriteProtectedMemory<float *>((LPVOID)0x0058B7D8, &fWideScreenWidthScaleDown);							// Text X position scale for the line count.
	WriteProtectedMemory<float *>((LPVOID)0x0058BA4E, &fWideScreenHeightScaleDown);							// Text height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058BA64, &fWideScreenWidthScaleDown);							// Text width scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058BCB2, &fWideScreenWidthScaleDown);							// Text width scale for the line width.
	WriteProtectedMemory<float *>((LPVOID)0x0058BD1B, &fWideScreenHeightScaleDown);							// Statistic text Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058BD5A, &fWideScreenWidthScaleDown);							// Statistic text X position scale.
	InstallHookJmp((LPVOID)0x0058BDDC, (LPVOID)0x0058BECD);
	WriteProtectedMemory<float *>((LPVOID)0x0058BF1E, &fWideScreenHeightScaleDown);							// Statistic increment/decrement foreground Y position and height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058BF80, &fWideScreenWidthScaleDown);							// Statistic increment/decrement foreground X position and width scale.
	InstallHookJmp((LPVOID)0x0058BF9C, HOOK_PTR_0058BF9C_drawMessageBox);									// Statistic meter Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058BFCD, &fWideScreenHeightScaleDown);							// Statistic plus/minus text Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058BFFE, &fWideScreenWidthScaleDown);							// Statistic plus/minus text X position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058BAC8, &fWideScreenWidthScaleDown);							// Message text X wrap scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058BBA9, &fWideScreenHeightScaleDown);							// Message text Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058BBDD, &fWideScreenWidthScaleDown);							// Message text X position scale.
	InstallHookOffShort((LPVOID)0x0058BB88, (LPVOID)0x0058BB92);
	// Subtitle text.
	/*InstallHookJmpShort((LPVOID)0x0046918E, (LPVOID)0x004691A2);
	WriteProtectedMemory<WORD>((LPVOID)0x0058C250, LITTLE_ENDIAN_WORD(INSTR_SUB_ESP_IMM8));
	WriteProtectedMemory<BYTE>((LPVOID)0x0058C252, 0x10);
	InstallHookJmpShort((LPVOID)0x0058C253, (LPVOID)0x0058C260);
	InstallHookJmpShort((LPVOID)0x0058C342, (LPVOID)0x0058C349);
	InstallHookJmpShort((LPVOID)0x0058C3E7, (LPVOID)0x0058C3F7);
	InstallHookJmpShort((LPVOID)0x0058C400, (LPVOID)0x0058C407);
	WriteProtectedMemory<const char *>((LPVOID)0x0058C3C1, szSubtitleText);
	WriteProtectedMemory<const char *>((LPVOID)0x0058C478, szSubtitleText);
	WriteProtectedMemory<const char *>((LPVOID)0x0058C54B, szSubtitleText);
	WriteProtectedMemory<const char *>((LPVOID)0x0058C618, szSubtitleText);
	*VAR_pbSubtitleTextChangedPos = false;
	*VAR_psSubtitleTextCentreSize = 370;
	*VAR_psSubtitleTextPosX = 355;*/
	WriteProtectedMemory<float *>((LPVOID)0x0058C361, &fWideScreenWidthScaleDown);							// Cutscene text centre size scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058C381, &fWideScreenHeightScaleDown);							// Cutscene text height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058C397, &fWideScreenWidthScaleDown);							// Cutscene text width scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058C3B6, &fWideScreenHeightScaleDown);							// Cutscene text Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058C409, &fWideScreenHeightScaleDown);							// Positioning/Normal text height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058C41F, &fWideScreenWidthScaleDown);							// Positioning/Normal text width scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058C451, &fWideScreenWidthScaleDown);							// Positioning text centre size scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058C470, &fWideScreenHeightScaleDown);							// Positioning text Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058C4C8, &fWideScreenHeightScaleDown);							// Stat box dependent text height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058C4DE, &fWideScreenWidthScaleDown);							// Stat box dependent text width scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058C501, &fWideScreenWidthScaleDown);							// Stat box dependent text centre size scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058C546, &fWideScreenHeightScaleDown);							// Stat box dependent text Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058C5D4, &fWideScreenWidthScaleDown);							// Normal text centre size scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058C613, &fWideScreenHeightScaleDown);							// Normal text Y position scale.
	// Mission text.
	/*InstallHookJmpShort((LPVOID)0x005888B5, (LPVOID)0x005888C1);
	InstallHookJmpShort((LPVOID)0x00588AF4, (LPVOID)0x00588B41);
	InstallHookJmpShort((LPVOID)0x0058905E, (LPVOID)0x00589064);*/
	/*InstallHookJmpShort((LPVOID)0x0058C6E0, (LPVOID)0x0058C6ED);
	WriteProtectedMemory<char *>((LPVOID)0x0058C705, szStyledText4);
	WriteProtectedMemory<char *>((LPVOID)0x0058C730, szStyledText6);
	WriteProtectedMemory<char *>((LPVOID)0x0058C73D, szStyledText3);
	WriteProtectedMemory<BYTE>((LPVOID)0x0058CA0A, INSTR_POP_ESI);
	InstallHookJmpShort((LPVOID)0x0058CA0B, (LPVOID)0x0058CA3B);
	strcpy(VAR_pszMissionText, "MISSION FAILED!");*/
	WriteProtectedMemory<float *>((LPVOID)0x0058C6CE, &fWideScreenHeightScaleDown);							// Text initial relative Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058C76D, &fWideScreenHeightScaleDown);							// Monoline text relative Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058C7AB, &fWideScreenHeightScaleDown);							// Multiline text relative Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058C7F2, &fWideScreenHeightScaleDown);							// Text relative Y position scale when the title text is printed.
	WriteProtectedMemory<float *>((LPVOID)0x0058C813, &fWideScreenHeightScaleDown);							// Text relative Y position scale when the odd-job and reward texts (A) are printed.
	WriteProtectedMemory<float *>((LPVOID)0x0058C84F, &fWideScreenHeightScaleDown);							// Text height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058C865, &fWideScreenWidthScaleDown);							// Text width scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058C897, &fWideScreenWidthScaleDown);							// Text centre size scale.
	// Title text.
	/*InstallHookJmpShort((LPVOID)0x0058CA51, (LPVOID)0x0058CA5E);
	strcpy(VAR_pszTitleText, "Imports");*/
	WriteProtectedMemory<float *>((LPVOID)0x0058CA8B, &fWideScreenHeightScaleDown);							// Text initial relative Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058CB0E, &fWideScreenHeightScaleDown);							// Text relative Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058CB36, &fWideScreenHeightScaleDown);							// Text relative Y position scale when the mission text is printed.
	WriteProtectedMemory<float *>((LPVOID)0x0058CBAD, &fWideScreenHeightScaleDown);							// Text height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058CBC3, &fWideScreenWidthScaleDown);							// Text width scale.
	// Secondary mission text.
	/*//InstallHookJmpShort((LPVOID)0x0058CC92, (LPVOID)0x0058CC9F);
	InstallHookJmpShort((LPVOID)0x0058CC9F, (LPVOID)0x0058CCAC);
	strcpy(VAR_pszOddJobTextB, "VIGILANTE");
	InstallHookJmpShort((LPVOID)0x0058CDAA, (LPVOID)0x0058CDB7);
	strcpy(VAR_pszRewardTextB, "REWARD $50");
	InstallHookJmpShort((LPVOID)0x0058CEA6, (LPVOID)0x0058CEB3);
	strcpy(VAR_pszOddJobTextA, "GO!");
	//InstallHookJmpShort((LPVOID)0x0058D12A, (LPVOID)0x0058D137);
	strcpy(VAR_pszRewardTextA, "Asset acquired!");*/
	WriteProtectedMemory<float *>((LPVOID)0x0058CCC7, &fWideScreenHeightScaleDown);							// Odd-job text (B) height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058CCDD, &fWideScreenWidthScaleDown);							// Odd-job text (B) width scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058CD08, &fWideScreenWidthScaleDown);							// Odd-job text (B) centre size scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058CDD2, &fWideScreenHeightScaleDown);							// Reward text (B) height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058CDE8, &fWideScreenWidthScaleDown);							// Reward text (B) width scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058CE0D, &fWideScreenWidthScaleDown);							// Reward text (B) centre size scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058CECE, &fWideScreenHeightScaleDown);							// Odd-job text (A) height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058CEE4, &fWideScreenWidthScaleDown);							// Odd-job text (A) width scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058CF0F, &fWideScreenWidthScaleDown);							// Odd-job text (A) centre size scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058D148, &fWideScreenHeightScaleDown);							// Reward text (A) height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058D15E, &fWideScreenWidthScaleDown);							// Reward text (A) width scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058D189, &fWideScreenWidthScaleDown);							// Reward text (A) centre size scale.
	// Load mission text.
	/*InstallHookJmpShort((LPVOID)0x0058D241, (LPVOID)0x0058D24E);
	InstallHookJmpShort((LPVOID)0x0058D3C8, (LPVOID)0x0058D3CF);
	strcpy(VAR_pszLoadMissionText, "Big Smoke");*/
	WriteProtectedMemory<float *>((LPVOID)0x0058D2C7, &fWideScreenHeightScaleDown);							// Text height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058D2DD, &fWideScreenWidthScaleDown);							// Text width scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058D449, &fWideScreenHeightScaleDown);							// Text Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058D45B, &fWideScreenWidthScaleDown);							// Text X position scale.
	// Weapon icon.
	WriteProtectedMemory<float *>((LPVOID)0x0058D884, &fWideScreenHeightScaleDown);							// Gun sprite height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058D8C5, &fWideScreenWidthScaleDown);							// Gun sprite width scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058D92F, &fWideScreenWidthScaleDown);							// Fist sprite width scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058D947, &fWideScreenHeightScaleDown);							// Fist sprite height scale.
	// Wanted level.
	/*WriteProtectedMemory<BYTE>((LPVOID)0x0058D9A7, INSTR_MOV_EBP_IMM32);
	WriteProtectedMemory<DWORD>((LPVOID)0x0058D9A8, 3);
	WriteProtectedMemory<BYTE>((LPVOID)0x0058D9AC, INSTR_MOV_EAX_IMM32);
	WriteProtectedMemory<DWORD>((LPVOID)0x0058D9AD, 3);
	InstallHookJmpShort((LPVOID)0x0058D9B1, (LPVOID)0x0058D9B8);
	InstallHookJmpShort((LPVOID)0x0058D9BE, (LPVOID)0x0058D9C1);
	WriteProtectedMemory<BYTE>((LPVOID)0x0058D9D6, 0x1C);
	InstallHookJmpShort((LPVOID)0x0058D9DC, (LPVOID)0x0058D9DF);*/
	InstallHookJmpShort((LPVOID)0x0058DC9C, (LPVOID)0x0058DCCC);
	WriteProtectedMemory<float *>((LPVOID)0x0058DD02, &fWideScreenWidthScaleDown);							// Rightmost star X position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058DD6A, &fWideScreenHeightScaleDown);							// Stars foreground text height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058DD80, &fWideScreenWidthScaleDown);							// Stars foreground text width scale.
	InstallHookJmp((LPVOID)0x0058DDD9, (LPVOID)0x0058DECF);
	WriteProtectedMemory<float *>((LPVOID)0x0058DF57, &fWideScreenHeightScaleDown);							// Stars background text height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058DF73, &fWideScreenWidthScaleDown);							// Stars background text width scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058DF9D, &fWideScreenHeightScaleDown);							// Stars background Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058DFE7, &fWideScreenWidthScaleDown);							// Stars relative X position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058DEE6, &fWideScreenHeightScaleDown);							// Stars foreground Y position scale.
	// Weapon crosshair.
	/*InstallHookJmpShort((LPVOID)0x0058E02A, (LPVOID)0x0058E031);
	InstallHookJmpShort((LPVOID)0x0058E037, (LPVOID)0x0058E03D);*/
	/*InstallHookJmp((LPVOID)0x0058E045, (LPVOID)0x0058E24A);
	InstallHookJmpShort((LPVOID)0x00609D03, (LPVOID)0x00609D84);*/
	//InstallHookJmp((LPVOID)0x0058E045, (LPVOID)0x0058E4DF);
	/*InstallHookJmpShort((LPVOID)0x0058E023, (LPVOID)0x0058E03D);
	WriteProtectedMemory<BYTE>((LPVOID)0x0058E03F, INSTR_PUSH_ESI);*/
	//InstallHookJmp((LPVOID)0x0058E040, (LPVOID)0x0058E74F);
	/*InstallHookJmp((LPVOID)0x0058E040, (LPVOID)0x0058E7C8);
	//InstallHookJmp((LPVOID)0x0058E040, (LPVOID)0x0058E7F2);
	InstallHookJmpShort((LPVOID)0x0058E81A, (LPVOID)0x0058E82E);
	WriteProtectedMemory<BYTE>((LPVOID)0x0058E831, 0x1C);
	WriteProtectedMemory<BYTE>((LPVOID)0x0058E835, 0x10);
	WriteProtectedMemory<BYTE>((LPVOID)0x0058E83D, 0x14);
	WriteProtectedMemory<BYTE>((LPVOID)0x0058E842, INSTR_MOV_EAX_IMM32);
	WriteProtectedMemory<int>((LPVOID)0x0058E843, WEAPONMODEL_SNIPERRIFLE);
	//WriteProtectedMemory<int>((LPVOID)0x0058E843, WEAPONMODEL_CAMERA);
	InstallHookJmpShort((LPVOID)0x0058E847, (LPVOID)0x0058E855);*/
	/*WriteProtectedMemory<WORD>((LPVOID)0x0058E271, LITTLE_ENDIAN_WORD(INSTR_FSTP_PTR32ESPADDOFF8 >> 8));
	InstallHookJmpShort((LPVOID)0x0058E275, (LPVOID)0x0058E282);*/
	WriteProtectedMemory<float *>((LPVOID)0x0058E28D, &fWideScreenWidthScaled);								// Smallest white dot top-left X position.
	WriteProtectedMemory<float *>((LPVOID)0x0058E2AE, &fWideScreenHeightScaled);							// Smallest white dot top-left Y position.
	WriteProtectedMemory<float *>((LPVOID)0x0058E2BC, &fWideScreenWidthScaled);								// Smallest white dot bottom-right X position.
	WriteProtectedMemory<float *>((LPVOID)0x0058E2CA, &fWideScreenHeightScaled);							// Smallest white dot bottom-right Y position.
	WriteProtectedMemory<float *>((LPVOID)0x0058E2FC, &fWideScreenWidthScaleDown);							// TPS site M16 sprite width scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058E31B, &fWideScreenHeightScaleDown);							// TPS site M16 sprite height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058E4EF, &fWideScreenWidthScaleDown);							// FPS site M16 sprite width scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058E529, &fWideScreenHeightScaleDown);							// FPS site M16 sprite height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058E75D, &fWideScreenWidthScaleDown);							// FPS site rocket sprite width scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058E775, &fWideScreenHeightScaleDown);							// FPS site rocket sprite height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058E7D0, &fWideScreenWidthScaleDown);							// FPS sniper crosshair sprite width scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058E7E6, &fWideScreenHeightScaleDown);							// FPS sniper crosshair sprite height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058E7FA, &fWideScreenWidthScaleDown);							// FPS camera crosshair sprite width scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058E810, &fWideScreenHeightScaleDown);							// FPS camera crosshair sprite height scale.
	// HUD interface.
	/*InstallHookJmpShort((LPVOID)0x005890CB, (LPVOID)0x005890E2);
	InstallHookJmpShort((LPVOID)0x0058F0D7, (LPVOID)0x0058F0DB);
	InstallHookJmpShort((LPVOID)0x0058F147, (LPVOID)0x0058F14B);*/
	WriteProtectedMemory<float *>((LPVOID)0x0058EB2B, &fWideScreenHeightScaleDown);							// Day time text height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058EB41, &fWideScreenWidthScaleDown);							// Day time text width scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058EBFB, &fWideScreenHeightScaleDown);							// Day time text Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058EC0E, &fWideScreenWidthScaleDown);							// Day time text X position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058EE62, &fWideScreenHeightScaleDown);							// First player health meter Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058EE80, &fWideScreenWidthScaleDown);							// First player health meter X position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058EECA, &fWideScreenHeightScaleDown);							// Second player health meter Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058EEF6, &fWideScreenWidthScaleDown);							// Second player health meter X position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058EF34, &fWideScreenHeightScaleDown);							// First player armour meter Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058EF52, &fWideScreenWidthScaleDown);							// First player armour meter X position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058EF9B, &fWideScreenHeightScaleDown);							// Second player armour meter Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058EFC7, &fWideScreenWidthScaleDown);							// Second player armour meter X position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058F0FA, &fWideScreenHeightScaleDown);							// First player breath meter Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058F118, &fWideScreenWidthScaleDown);							// First player breath meter X position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058F16A, &fWideScreenHeightScaleDown);							// Second player breath meter Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058F196, &fWideScreenWidthScaleDown);							// Second player breath meter X position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058F548, &fWideScreenHeightScaleDown);							// Money text height scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058F55E, &fWideScreenWidthScaleDown);							// Money text width scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058F5D0, &fWideScreenHeightScaleDown);							// Money text Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058F5F6, &fWideScreenWidthScaleDown);							// Money text X position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058F90D, &fWideScreenHeightScaleDown);							// First player weapon icon Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058F91E, &fWideScreenWidthScaleDown);							// First player weapon icon X position scale.
	WriteProtectedMemory<const float *>((LPVOID)0x0058F927, &fWeaponHudComponentsPosX);
	InstallHookJmpShort((LPVOID)0x0058F92B, (LPVOID)0x0058F935);
	WriteProtectedMemory<float *>((LPVOID)0x0058F974, &fWideScreenHeightScaleDown);							// Second player weapon icon Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058F995, &fWideScreenWidthScaleDown);							// Second player weapon icon X position scale.
	WriteProtectedMemory<const float *>((LPVOID)0x0058F99C, &fWeaponHudComponentsPosX);
	InstallHookJmpShort((LPVOID)0x0058F9A0, (LPVOID)0x0058F9A6);
	WriteProtectedMemory<float *>((LPVOID)0x0058F9C2, &fWideScreenHeightScaleDown);							// First player weapon ammo Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058F9D2, &fWideScreenWidthScaleDown);							// First player weapon ammo X position scale.
	InstallHookJmpShort((LPVOID)0x0058F9F1, (LPVOID)0x0058F9FB);
	WriteProtectedMemory<const float *>((LPVOID)0x0058FA02, &fWeaponHudComponentsPosX);
	NopProtectedMemory((LPVOID)0x0058FA06, sizeof(WORD));
	WriteProtectedMemory<float *>((LPVOID)0x0058FA4C, &fWideScreenHeightScaleDown);							// Second player weapon ammo Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x0058FA5F, &fWideScreenWidthScaleDown);							// Second player weapon ammo X position scale.
	InstallHookJmpShort((LPVOID)0x0058FA8A, (LPVOID)0x0058FA94);
	WriteProtectedMemory<const float *>((LPVOID)0x0058FA9B, &fWeaponHudComponentsPosX);
	NopProtectedMemory((LPVOID)0x0058FA9F, sizeof(WORD));
	// Loading screens.

	// Loading meter.

	// Credit text.
	WriteProtectedMemory<WORD>((LPVOID)0x005A8660, LITTLE_ENDIAN_WORD(INSTR_FLD_PTR32));
	WriteProtectedMemory<float *>((LPVOID)0x005A8662, VAR_pfScreenHeightStd);								// Swap the current screen height with the standard one.
	InstallHookJmp((LPVOID)0x005A867B, HOOK_PTR_005A867B_drawCreditText);									// Text position and size.
	// Credits.
	InstallHookJmp((LPVOID)0x005A881E, HOOK_PTR_005A881E_drawCredits);										// Texts Y position speed.
	InstallHookJmp((LPVOID)0x005A883A, HOOK_PTR_005A883A_drawCredits);										// Texts centre size.
	WriteProtectedMemory<float *>((LPVOID)0x005AF8E9, &fWideScreenHeightScaledInv);							// Texts ending Y position.
	// Load font textures.
	WriteProtectedMemory<float *>((LPVOID)0x005BA6EB, &fWideScreenHeightScaled);							// Initial texts Y position scale.
	WriteProtectedMemory<float *>((LPVOID)0x005BA6F0, &fWideScreenWidthScaled);								// Initial texts X position scale.
	// Unknown 2D stuff coordinates precalculation (0x00701450).
	WriteProtectedMemory<float *>((LPVOID)0x0070149D, &fWideScreenWidthScaleDown);
	WriteProtectedMemory<float *>((LPVOID)0x007014C5, &fWideScreenHeightScaleDown);
	WriteProtectedMemory<float *>((LPVOID)0x00701528, &fWideScreenWidthScaleDown);
	WriteProtectedMemory<float *>((LPVOID)0x00701551, &fWideScreenHeightScaleDown);
	WriteProtectedMemory<float *>((LPVOID)0x007015A4, &fWideScreenWidthScaleDown);
	WriteProtectedMemory<float *>((LPVOID)0x007015CC, &fWideScreenHeightScaleDown);
	WriteProtectedMemory<float *>((LPVOID)0x00701645, &fWideScreenWidthScaleDown);
	WriteProtectedMemory<float *>((LPVOID)0x00701663, &fWideScreenHeightScaleDown);
	// Unknown 2D stuff (0x00702F40).
	WriteProtectedMemory<float *>((LPVOID)0x00702F9C, &fWideScreenHeightScaleDown);
	// Unknown 2D stuff (0x007037C0).
	WriteProtectedMemory<WORD>((LPVOID)0x0070389E, LITTLE_ENDIAN_WORD(INSTR_ADD_ESP_IMM8));
	WriteProtectedMemory<BYTE>((LPVOID)0x007038A0, 0x10);
	InstallHookJmpShort((LPVOID)0x007038A1, (LPVOID)0x007038B3);
	WriteProtectedMemory<float *>((LPVOID)0x007038BD, &fWideScreenWidthScaleDown);
	// Unknown 2D stuff (0x007046E0).
	WriteProtectedMemory<float *>((LPVOID)0x00705260, &fWideScreenHeightScaleDown);
	WriteProtectedMemory<float *>((LPVOID)0x00705280, &fWideScreenWidthScaleDown);
	// Unknown 2D stuff (0x00719B40).
	WriteProtectedMemory<float *>((LPVOID)0x00719C0F, &fWideScreenWidthScaleDown);
	WriteProtectedMemory<float *>((LPVOID)0x00719C29, &fWideScreenHeightScaleDown);
	WriteProtectedMemory<float *>((LPVOID)0x00719C5A, &fWideScreenHeightScaleDown);
	WriteProtectedMemory<float *>((LPVOID)0x00719C70, &fWideScreenWidthScaleDown);
	WriteProtectedMemory<float *>((LPVOID)0x00719D2F, &fWideScreenWidthScaleDown);
	WriteProtectedMemory<float *>((LPVOID)0x00719D49, &fWideScreenHeightScaleDown);
	WriteProtectedMemory<float *>((LPVOID)0x00719D7E, &fWideScreenHeightScaleDown);
	WriteProtectedMemory<float *>((LPVOID)0x00719D96, &fWideScreenWidthScaleDown);
	WriteProtectedMemory<float *>((LPVOID)0x00719DB7, &fWideScreenHeightScaleDown);
	WriteProtectedMemory<float *>((LPVOID)0x00719DD3, &fWideScreenWidthScaleDown);
	WriteProtectedMemory<float *>((LPVOID)0x00719DF4, &fWideScreenHeightScaleDown);
	WriteProtectedMemory<float *>((LPVOID)0x00719E10, &fWideScreenWidthScaleDown);
	WriteProtectedMemory<float *>((LPVOID)0x00719E31, &fWideScreenHeightScaleDown);
	WriteProtectedMemory<float *>((LPVOID)0x00719E4D, &fWideScreenWidthScaleDown);
	WriteProtectedMemory<float *>((LPVOID)0x00719E71, &fWideScreenWidthScaleDown);
	WriteProtectedMemory<float *>((LPVOID)0x00719E99, &fWideScreenWidthScaleDown);
	WriteProtectedMemory<float *>((LPVOID)0x00719EC1, &fWideScreenHeightScaleDown);
	WriteProtectedMemory<float *>((LPVOID)0x00719EE5, &fWideScreenHeightScaleDown);
	// Transform 3D coordinates to 2D point in clip.
	InstallHookJmp((LPVOID)0x0070CEAD, HOOK_PTR_0070CEAD_transform3DTo2DPointInClip);						// Scale 2D point multipliers (first overload).
	// Text character (including fix for characters disappering when on leftmost and topmost of the screen).
	WriteProtectedMemory<WORD>((LPVOID)0x00718A10, LITTLE_ENDIAN_WORD(INSTR_SUB_ESP_IMM8));
	WriteProtectedMemory<BYTE>((LPVOID)0x00718A12, 0x20);
	InstallHookJmpShort((LPVOID)0x00718A13, (LPVOID)0x00718A67);
	// Text processing (including fix for left-aligned multi-line texts).
	InstallHookOffShort((LPVOID)0x0071A37A, (LPVOID)0x0071A38F);
	WriteProtectedMemory<DWORD>((LPVOID)0x0071A38F, LITTLE_ENDIAN_DWORD((INSTR_FLD_PTR32ESPADDOFF8 << 8) | 0x14));
	InstallHookJmpShort((LPVOID)0x0071A399, (LPVOID)0x0071A3A8);
	// Text rectangle coordinates.
	InstallHookJmp((LPVOID)0x0071A63C, HOOK_PTR_0071A63C_getTextRect);										// Text padding.
	WriteProtectedMemory<WORD>((LPVOID)0x0071A653, LITTLE_ENDIAN_WORD(INSTR_FADD_ST0_STI + 1));
	InstallHookJmpShort((LPVOID)0x0071A655, (LPVOID)0x0071A659);
	WriteProtectedMemory<WORD>((LPVOID)0x0071A66B, LITTLE_ENDIAN_WORD(INSTR_FADDP_STI_ST0 + 1));
	InstallHookJmpShort((LPVOID)0x0071A66D, (LPVOID)0x0071A671);
	WriteProtectedMemory<WORD>((LPVOID)0x0071A68B, LITTLE_ENDIAN_WORD(INSTR_FSUB_ST0_STI + 1));
	InstallHookJmpShort((LPVOID)0x0071A68D, (LPVOID)0x0071A691);
	WriteProtectedMemory<WORD>((LPVOID)0x0071A69D, LITTLE_ENDIAN_WORD(INSTR_FSUB_ST0_STI + 1));
	InstallHookJmpShort((LPVOID)0x0071A69F, (LPVOID)0x0071A6A3);
	WriteProtectedMemory<WORD>((LPVOID)0x0071A6AB, LITTLE_ENDIAN_WORD(INSTR_FADDP_STI_ST0 + 1));
	InstallHookJmpShort((LPVOID)0x0071A6AD, (LPVOID)0x0071A6B1);
	WriteProtectedMemory<WORD>((LPVOID)0x0071A6BF, LITTLE_ENDIAN_WORD(INSTR_FSUB_ST0_STI + 1));
	InstallHookJmpShort((LPVOID)0x0071A6C1, (LPVOID)0x0071A6C5);
	WriteProtectedMemory<WORD>((LPVOID)0x0071A6EC, LITTLE_ENDIAN_WORD(INSTR_FADDP_STI_ST0 + 1));
	InstallHookJmpShort((LPVOID)0x0071A6EE, (LPVOID)0x0071A6F2);
	// Top text.
	WriteProtectedMemory<float *>((LPVOID)0x0071A798, &fWideScreenHeightScaled);							// Background top padding.
	WriteProtectedMemory<float *>((LPVOID)0x0071A7AF, &fWideScreenHeightScaled);							// Background bottom padding.
	WriteProtectedMemory<float *>((LPVOID)0x0071A7C7, &fWideScreenWidthScaled);								// Background left padding.
	WriteProtectedMemory<float *>((LPVOID)0x0071A7D5, &fWideScreenWidthScaled);								// Background right padding.
	// Transform 3D coordinates to 2D point.
	InstallHookJmp((LPVOID)0x0071DA42, HOOK_PTR_0071DA42_transform3DTo2DPoint);								// Scale 2D point multipliers (second overload).
	// Unknown 2D stuff (0x00721660).
	WriteProtectedMemory<float *>((LPVOID)0x0072167C, &fWideScreenHeightScaleDown);
	WriteProtectedMemory<float *>((LPVOID)0x00721692, &fWideScreenWidthScaleDown);
	WriteProtectedMemory<float *>((LPVOID)0x00721947, &fWideScreenHeightScaleDown);
	WriteProtectedMemory<float *>((LPVOID)0x0072195D, &fWideScreenWidthScaleDown);
	// Meter.
	WriteProtectedMemory<float *>((LPVOID)0x00728866, &fWideScreenHeightScaleDown);							// Top border height scale.
	WriteProtectedMemory<float *>((LPVOID)0x007288AB, &fWideScreenHeightScaleDown);							// Bottom border height scale.
	WriteProtectedMemory<float *>((LPVOID)0x007288F7, &fWideScreenWidthScaleDown);							// Left border width scale.
	WriteProtectedMemory<float *>((LPVOID)0x00728943, &fWideScreenWidthScaleDown);							// Right border width scale.
	// Unknown 2D stuff (0x00731280).
	WriteProtectedMemory<float *>((LPVOID)0x007313C1, &fWideScreenWidthScaleDown);
	WriteProtectedMemory<float *>((LPVOID)0x007313EF, &fWideScreenHeightScaleDown);
	WriteProtectedMemory<float *>((LPVOID)0x00731448, &fWideScreenHeightScaleDown);
	WriteProtectedMemory<float *>((LPVOID)0x0073145E, &fWideScreenWidthScaleDown);
	WriteProtectedMemory<float *>((LPVOID)0x0073147B, &fWideScreenWidthScaleDown);
	// Device selection.
	InstallHookJmp((LPVOID)0x007462BF, HOOK_PTR_007462BF_psSelectDevice);									// Set current video ratio.
	InstallHookJmp((LPVOID)0x007462F4, HOOK_PTR_007462F4_psSelectDevice);									// Set video ratio.
	// Unknown 2D stuff (0x00854820).
	WriteProtectedMemory<float *>((LPVOID)0x00854828, &fWideScreenWidthScaleDown);
	// Unknown 2D stuff (0x00854840).
	WriteProtectedMemory<float *>((LPVOID)0x00854848, &fWideScreenHeightScaleDown);
	// Unknown 2D stuff (0x00854860).
	WriteProtectedMemory<float *>((LPVOID)0x00854868, &fWideScreenWidthScaleDown);
	// Unknown 2D stuff (0x00854880).
	WriteProtectedMemory<float *>((LPVOID)0x00854888, &fWideScreenHeightScaleDown);

	//addTextKeyInSortedList(FUNC_getCrc32FromString("FED_SAR"), "Aspect Ratio", CLASS_pclText->m_clMainKeys.m_paclKeys);
	//InstallHookJmpShort((LPVOID)0x007FB7DB, (LPVOID)0x007FB7E2);
}

char *getDisplayModeAdapterIdName(int iAdapter) {
	char szAdapter[12];

	return !iAdapter ? STRINGIZE_PATTERN(D3DADAPTER_DEFAULT) : itoa(iAdapter, szAdapter, 10);
}

char *getDisplayModeFormatName(D3DFORMAT eFormat) {
	switch(eFormat) {
		case D3DFMT_A8R8G8B8:
			return STRINGIZE_PATTERN(D3DFMT_A8R8G8B8);
		case D3DFMT_X8R8G8B8:
			return STRINGIZE_PATTERN(D3DFMT_X8R8G8B8);
		case D3DFMT_R5G6B5:
			return STRINGIZE_PATTERN(D3DFMT_R5G6B5);
		case D3DFMT_X1R5G5B5:
			return STRINGIZE_PATTERN(D3DFMT_X1R5G5B5);
		case D3DFMT_A1R5G5B5:
			return STRINGIZE_PATTERN(D3DFMT_A1R5G5B5);
		case D3DFMT_A2R10G10B10:
			return STRINGIZE_PATTERN(D3DFMT_A2R10G10B10);
	}

	return STRINGIZE_PATTERN(D3DFMT_UNKNOWN);
}

// COMMAND_GET_HEIGHT_IN_WORLD_LEVEL
float getHeightInWorldLevel(float fPosZ) {
	float fHeight;

	if(fPosZ <= -100.0f) {
		fHeight = 100.0f;
	} else if(fPosZ <= 0.0f) {
		fHeight = -fPosZ;
	} else if(fPosZ <= 200.0f) {
		fHeight = fPosZ;
	} else if(fPosZ <= 950.0f) {
		fHeight = fPosZ - 200.0f;
	} else if(fPosZ < 1500.0f) {
		fHeight = fPosZ - 950.0f;
	} else {
		fHeight = 1500.0f - 950.0f;
	}

	return fHeight;
}

// COMMAND_GET_HEIGHT_PERCENT_IN_WORLD_LEVEL
float getHeightPercentInWorldLevel(float fPosZ) {
	float fHeightPerc;

	if(fPosZ <= -100.0f) {
		fHeightPerc = 100.0f;
	} else if(fPosZ <= 0.0f) {
		fHeightPerc = -fPosZ;
	} else if(fPosZ <= 200.0f) {
		fHeightPerc = fPosZ * (100.0f / 200.0f);
	} else if(fPosZ <= 950.0f) {
		fHeightPerc = (fPosZ - 200.0f) * (100.0f / (950.0f - 200.0f));
	} else if(fPosZ < 1500.0f) {
		fHeightPerc = (fPosZ - 950.0f) * (100.0f / (1500.0f - 950.0f));
	} else {
		fHeightPerc = 100.0f;
	}

	return fHeightPerc;
}

short findTextKeyIndex(unsigned int uiKey, CTextKey *paclTextKeys, short sFirst, short sLast) {
	short sCurrent;

	while(sLast >= sFirst) {
		sCurrent = sFirst + (sLast - sFirst) / 2;

		if(paclTextKeys[sCurrent].m_uiKey < uiKey) {
			sFirst = sCurrent + 1;
		} else if(paclTextKeys[sCurrent].m_uiKey > uiKey) {
			sLast = sCurrent - 1;
		} else {
			return sCurrent;
		}
	}

	return ~(sCurrent + (sCurrent != sFirst));
}

CTextKey *addTextKeyInSortedList(unsigned int uiKey, char *pszData, CTextKey *paclTextKeys) {
	short sCurrent, sIndex;
	int iSize;

	sCurrent = findTextKeyIndex(
		uiKey,
		CLASS_pclText->m_clMainKeys.m_paclKeys,
		0,
		CLASS_pclText->m_clMainKeys.m_sCount - 1
	);

	if(sCurrent < 0) {
		sCurrent = ~sCurrent;

		CLASS_pclText->m_clMainKeys.m_paclKeys = (CTextKey *)FUNC_realloc(
			CLASS_pclText->m_clMainKeys.m_paclKeys,
			sizeof(CTextKey) * ++CLASS_pclText->m_clMainKeys.m_sCount
		);

		for(sIndex = CLASS_pclText->m_clMainKeys.m_sCount; sIndex > sCurrent; sIndex--) {
			CLASS_pclText->m_clMainKeys.m_paclKeys[sIndex] = CLASS_pclText->m_clMainKeys.m_paclKeys[sIndex - 1];
		}

		iSize = CLASS_pclText->m_clMainData.m_iSize;
		CLASS_pclText->m_clMainData.m_iSize += strlen(pszData) + 1;
		CLASS_pclText->m_clMainData.m_pacData = (char *)FUNC_realloc(
			CLASS_pclText->m_clMainData.m_pacData,
			CLASS_pclText->m_clMainData.m_iSize
		);
		strcpy(&CLASS_pclText->m_clMainData.m_pacData[iSize], pszData);

		CLASS_pclText->m_clMainKeys.m_paclKeys[sCurrent].m_pszData = &CLASS_pclText->m_clMainData.m_pacData[iSize];
		CLASS_pclText->m_clMainKeys.m_paclKeys[sCurrent].m_uiKey = uiKey;

		return &CLASS_pclText->m_clMainKeys.m_paclKeys[sCurrent];
	}

	return NULL;
}

inline float getDynamicScreenFieldOfView(float fFactor) {
	return fFactor * fDynamicScreenFieldOfViewScale;
}

void setScreenFieldOfView(float fFactor) {
	*VAR_pfScreenFieldOfView = /*!CLASS_pclCamera->m_bWidescreen ? */getDynamicScreenFieldOfView(fFactor)/* : fFactor*/;
}

void updateScreenAspectRatio() {
	*VAR_pfScreenAspectRatio = (float)CLASS_pclRsGlobal->m_iScreenWidth / (float)CLASS_pclRsGlobal->m_iScreenHeight;

	if(*VAR_pfScreenAspectRatio >= 1.0f) {
		fWideScreenWidthRatio = 1.0f / *VAR_pfScreenAspectRatio;
		fWideScreenHeightRatio = 1.0f;
		fWideScreenWidthPerc = fWideScreenWidthRatio * SCREEN_AR_STRETCH;
		fWideScreenWidthDiff = 1.0f - fWideScreenWidthPerc;
		fWideScreenWidthMult = 2.0f - fWideScreenWidthPerc;
		fWideScreenWidthScaleUp = SCREEN_SCALE_WIDTH * fWideScreenWidthMult;
		fWideScreenWidthScaleMid = SCREEN_SCALE_WIDTH * fWideScreenWidthDiff;
		fWideScreenWidthScaleDown = SCREEN_SCALE_WIDTH * fWideScreenWidthPerc;
		fWideScreenHeightPerc = 1.0f;
		fWideScreenHeightDiff = 0.0f;
		fWideScreenHeightMult = 1.0f;
		fWideScreenHeightScaleUp = SCREEN_SCALE_HEIGHT;
		fWideScreenHeightScaleMid = 0.0f;
		fWideScreenHeightScaleDown = SCREEN_SCALE_HEIGHT;
	} else {
		fWideScreenWidthRatio = 1.0f;
		fWideScreenHeightRatio = *VAR_pfScreenAspectRatio;
		fWideScreenWidthPerc = 1.0f;
		fWideScreenWidthDiff = 0.0f;
		fWideScreenWidthMult = 1.0f;
		fWideScreenWidthScaleUp = SCREEN_SCALE_WIDTH;
		fWideScreenWidthScaleMid = 0.0f;
		fWideScreenWidthScaleDown = SCREEN_SCALE_WIDTH;
		fWideScreenHeightPerc = fWideScreenHeightRatio / SCREEN_AR_STRETCH;
		fWideScreenHeightDiff = 1.0f - fWideScreenHeightPerc;
		fWideScreenHeightMult = 2.0f - fWideScreenHeightPerc;
		fWideScreenHeightScaleUp = SCREEN_SCALE_HEIGHT * fWideScreenHeightMult;
		fWideScreenHeightScaleMid = SCREEN_SCALE_HEIGHT * fWideScreenHeightDiff;
		fWideScreenHeightScaleDown = SCREEN_SCALE_HEIGHT * fWideScreenHeightPerc;
	}

	fWideScreenWidthScaled = (float)CLASS_pclRsGlobal->m_iScreenWidth * fWideScreenWidthScaleDown;
	fWideScreenWidthScaledInv = 1.0f / fWideScreenWidthScaled;
	fWideScreenHeightScaled = (float)CLASS_pclRsGlobal->m_iScreenHeight * fWideScreenHeightScaleDown;
	fWideScreenHeightScaledInv = 1.0f / fWideScreenHeightScaled;

	fDynamicScreenFieldOfViewScale = 2.0f * RADIAN_TO_DEGREE(atan(tan(DEGREE_TO_RADIAN(fScreenFieldOfViewVStd * 0.5f)) * *VAR_pfScreenAspectRatio))
								   * (1.0f / SCREEN_FOV_HORIZONTAL);
}
/*
// The equivalent method of CMenuManager class has an unused object, thus it acts like an stdcall.
float __stdcall scaleToWideScreenWidth(float fCoordX) {
	return *VAR_piScreenWidth * fWideScreenWidthScaleDown * fCoordX;
}

float __stdcall scaleToWideScreenHeight(float fCoordY) {
	return *VAR_piScreenHeight * fWideScreenHeightScaleDown * fCoordY;
}
*/
void setVideo(int iModeIndex, int iRatioIndex) {
	SRwRaster *pstCameraRaster;

	FUNC_rwD3d9ChangeDisplayMode(iModeIndex);
	pstCameraRaster = VAR_pstGtaCamera->m_pstFrameBuffer;
	CLASS_pclRsGlobal->m_iScreenWidth = pstCameraRaster->m_iWidth;
	CLASS_pclRsGlobal->m_iScreenHeight = pstCameraRaster->m_iHeight;

	rwD3d9ChangeDisplayRatio(iRatioIndex);
	*VAR_pfScreenAspectRatio = stRwDisplayRatio.m_fRatio;

	PROC_updateCameraRaster();
}

void setVideoRatio(int iRatioIndex) {
	rwD3d9ChangeDisplayRatio(iRatioIndex);
	*VAR_pfScreenAspectRatio = stRwDisplayRatio.m_fRatio;

	PROC_precalc2dStuffCoords();
}

void rwD3d9CreateDisplayRatioList() {
	int iModeIndex, iRatioIndex;
	SRwD3d9DisplayMode *pstRwDisplayMode;
	int iNumDisplayModes;
	int iWidth, iHeight, iNumerator, iDenominator;
	float fRatio;

	//FILE *pstFile = fopen("test2.txt", "w");

	if(!*VAR_ppastRwDisplayModeList) {
		PROC_rwD3d9CreateDisplayModeList();
	}

	iNumDisplayModes = *VAR_piRwNumDisplayModes;

	for(iModeIndex = 0; iModeIndex < iNumDisplayModes; iModeIndex++) {
		pstRwDisplayMode = &(*VAR_ppastRwDisplayModeList)[iModeIndex];

		iWidth = pstRwDisplayMode->m_iWidth;
		iHeight = pstRwDisplayMode->m_iHeight;
		fRatio = (float)iWidth / (float)iHeight;

		if(iRwNumDisplayRatios) {
			if(pstRwDisplayMode->m_iAdapter != D3DADAPTER_DEFAULT) {
				for(iRatioIndex = 0; iRatioIndex < iRwNumDisplayRatios; iRatioIndex++) {
					if(pastRwDisplayRatioList[iRatioIndex].m_iAdapter != D3DADAPTER_DEFAULT
					&& pastRwDisplayRatioList[iRatioIndex].m_fRatio == fRatio) {
						pstRwDisplayMode->m_sRatioIndex = iRatioIndex;

						break;
					}
				}

				// Is goto really bad? The speed loves it sometime, the compiler doesn't unfortunately (better stick to its optimization).
				if(iRatioIndex != iRwNumDisplayRatios) {
					continue;
				}

				pastRwDisplayRatioList = (SRwD3d9DisplayRatio *)realloc(pastRwDisplayRatioList, ++iRwNumDisplayRatios * sizeof(SRwD3d9DisplayRatio));
			} else {
				iRatioIndex = iRwNumDisplayRatios++;
			}
		} else {
			pastRwDisplayRatioList = (SRwD3d9DisplayRatio *)malloc(sizeof(SRwD3d9DisplayRatio));
			iRatioIndex = iRwNumDisplayRatios++;
		}

		iNumerator = iWidth;
		iDenominator = iHeight;

		while(iNumerator != iDenominator) {
			if(iNumerator > iDenominator) {
				iNumerator -= iDenominator;
			} else {
				iDenominator -= iNumerator;
			}
		}

		pastRwDisplayRatioList[iRatioIndex].m_fRatio = fRatio;
		pastRwDisplayRatioList[iRatioIndex].m_iNumerator = iWidth / iNumerator;
		pastRwDisplayRatioList[iRatioIndex].m_iDenominator = iHeight / iNumerator;
		pastRwDisplayRatioList[iRatioIndex].m_iAdapter = pstRwDisplayMode->m_iAdapter;

		pstRwDisplayMode->m_sRatioIndex = iRatioIndex;

		/*fprintf(pstFile, "%d %f %d %d %d\n",
			iRatioIndex,
			pastRwDisplayRatioList[iRatioIndex].m_fRatio,
			pastRwDisplayRatioList[iRatioIndex].m_iNumerator,
			pastRwDisplayRatioList[iRatioIndex].m_iDenominator,
			pastRwDisplayRatioList[iRatioIndex].m_iAdapter
		);*/
	}

	//fclose(pstFile);
}

bool rwD3d9ChangeDisplayRatio(int iRatioIndex) {
	return rwEngineSetVideoRatio(iRatioIndex);
}

int rwEngineGetNumVideoRatios() {
	int iNumVideoRatios;

	if(FUNC_rwDeviceSystemRequest(&(*VAR_ppstRwEngineInstance)->m_stOpenDevice, RWSYSDEVREQUEST_GETNUMVIDEORATIOS, &iNumVideoRatios, NULL, 0)) {
		return iNumVideoRatios;
	}

	// Neither the default video mode is available.
	return -1;
}

int rwEngineGetCurrentVideoModeRatio(int iModeIndex) {
	int iCurrentVideoRatio;

	if(FUNC_rwDeviceSystemRequest(&(*VAR_ppstRwEngineInstance)->m_stOpenDevice, RWSYSDEVREQUEST_GETCURRENTVIDEOMODERATIO, &iCurrentVideoRatio, NULL, iModeIndex)) {
		return iCurrentVideoRatio;
	}

	return -1;
}

int rwEngineGetCurrentVideoRatio() {
	int iCurrentVideoRatio;

	if(FUNC_rwDeviceSystemRequest(&(*VAR_ppstRwEngineInstance)->m_stOpenDevice, RWSYSDEVREQUEST_GETCURRENTVIDEORATIO, &iCurrentVideoRatio, NULL, 0)) {
		return iCurrentVideoRatio;
	}

	return -1;
}

SRwVideoRatio *rwEngineGetVideoRatioInfo(SRwVideoRatio *pstRatioInfo, int iRatioIndex) {
	if(FUNC_rwDeviceSystemRequest(&(*VAR_ppstRwEngineInstance)->m_stOpenDevice, RWSYSDEVREQUEST_GETVIDEORATIOINFO, (void *)pstRatioInfo, NULL, iRatioIndex)) {
		return pstRatioInfo;
	}

	return NULL;
}

bool rwEngineSetVideoRatio(int iRatioIndex) {
	return FUNC_rwDeviceSystemRequest(&(*VAR_ppstRwEngineInstance)->m_stOpenDevice, RWSYSDEVREQUEST_SETVIDEORATIO, NULL, NULL, iRatioIndex);
}

char *psGetVideoMode(char *pszVideoMode, int iModeIndex) {
	SRwVideoMode stModeInfo;

	if(FUNC_rwEngineGetVideoModeInfo(&stModeInfo, iModeIndex)
	&& stModeInfo.m_iAdapter != D3DADAPTER_DEFAULT) {
		sprintf(pszVideoMode,
			"%d x %d x %d",
			stModeInfo.m_iWidth,
			stModeInfo.m_iHeight,
			stModeInfo.m_iDepth
		);
	} else {
		*pszVideoMode = '\0';
	}

	return pszVideoMode;
}

char *psGetVideoRatio(char *pszVideoRatio, int iRatioIndex) {
	SRwVideoRatio stRatioInfo;

	if(rwEngineGetVideoRatioInfo(&stRatioInfo, iRatioIndex)
	&& stRatioInfo.m_iAdapter != D3DADAPTER_DEFAULT) {
		sprintf(pszVideoRatio,
			"%d:%d (%s)",
			stRatioInfo.m_iNumerator,
			stRatioInfo.m_iDenominator,
			stRatioInfo.m_bWidescreen ? "WS" : "FS"
		);
	} else {
		*pszVideoRatio = '\0';
	}

	return pszVideoRatio;
}

void __declspec(naked) HOOK_PTR_0043CFE8_drawRampageCounter() {
	static const float fTimePosY = 136.0f;
	static const float fKillsRelPosY = 20.0f;
	static const float fLongHealthMeterHeightPlusPad = 12.0f;
	static const float fPlayer2HudHeightPlusPad = 72.0f;

	__asm {
		fmul	fWideScreenHeightScaleDown
		fld		st
		fmul	fTimePosY
		fld		st(1)
		fmul	fKillsRelPosY
		fadd	st, st(1)
		movzx	eax, ds:ADDR_ucPlayer
		imul	eax, 190h
		mov		cl, ds:[ADDR_aclPlayers]CPlayer.m_cMaxHealth[eax]
		cmp		cl, 101
		ja		short_health_meter_0
		fld		st(2)
		fmul	fLongHealthMeterHeightPlusPad
		fld		st
		fsubp	st(3), st
		fsubp	st(1), st
short_health_meter_0:
		mov		edx, ds:[ADDR_aclPlayers]CPlayer.m_pclPed+190h
		test	edx, edx
		jz		player2_unavailable
		mov		al, ds:[ADDR_aclPlayers]CPlayer.m_cMaxHealth+190h
		cmp		al, 101
		ja		short_health_meter_1
		fld		st(2)
		fmul	fLongHealthMeterHeightPlusPad
		fld		st
		fsubp	st(3), st
		fsubp	st(1), st
short_health_meter_1:
		fld		st(2)
		fmul	fPlayer2HudHeightPlusPad
		fld		st
		faddp	st(3), st
		faddp	st(1), st
player2_unavailable:
		fstp	dword ptr [esp+10h-0Ch]
		fstp	dword ptr [esp+10h-10h]
		fstp	st
		mov		ecx, ADDR_0043D095_drawRampageCounter
		jmp		ecx
	}
}

void __declspec(naked) HOOK_PTR_0045506D_drawPickupMoneyText() {
	static const float fMultScale = 1.0f / 30.0f;

	__asm {
		add		esp, 4
		fld		dword ptr [esi-0Ch]
		fmul	fMultScale
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fmul	fWideScreenHeightScaleDown
		fcom	st(1)
		fnstsw	ax
		test	ah, 5
		jp		store_ymult_scaling
		fxch	st(1)
store_ymult_scaling:
		fstp	st
		fstp	dword ptr [esp+24h-20h]
		fld		dword ptr [esi-10h]
		fmul	fMultScale
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fmul	fWideScreenWidthScaleDown
		fcom	st(1)
		fnstsw	ax
		test	ah, 5
		jp		store_xmult_scaling
		fxch	st(1)
store_xmult_scaling:
		fstp	st
		fstp	dword ptr [esp+24h-24h]
		mov		eax, ADDR_00455132_drawPickupMoneyText
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_005736B6_CMenuManager__setPage() {
	__asm {
		mov		[esi]CMenuManager.m_iSelectedVideoMode, edx
		mov		al, [esi]CMenuManager.m_cVideoRatio
		mov		cSelectedVideoRatio, al
		mov		ecx, ADDR_005736BC_CMenuManager__setPage
		jmp		ecx
	}
}

void __declspec(naked) HOOK_PTR_00573BDF_CMenuManager__resetPageSettings() {
	__asm {
		mov		[esi]CMenuManager.m_iSelectedVideoMode, edx
		mov		bl, [esi]CMenuManager.m_cVideoRatio
		mov		cSelectedVideoRatio, bl
		mov		edx, ADDR_00573BE5_CMenuManager__resetPageSettings
		jmp		edx
	}
}

void __declspec(naked) HOOK_PTR_00574037_CMenuManager__drawMessage() {
	static const float fPosX = 210.0f;

	__asm {
		fld		st
		fmul	fWideScreenWidthScaleDown
		fmul	fPosX
		fsubp	st(1), st
		mov		eax, ADDR_00574043_CMenuManager__drawMessage
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_00574075_CMenuManager__drawMessage() {
	static const float fWidth = 0.56f;
	//static const float fHeight = 1.0f;

	__asm {
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fmul	fWideScreenHeightScaleDown
		//fmul	fHeight
		fstp	dword ptr [esp+28h-24h]
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fmul	fWideScreenWidthScaleDown
		fmul	fWidth
		fstp	dword ptr [esp+28h-28h]
		mov		eax, ADDR_005740D0_CMenuManager__drawMessage
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_005740D5_CMenuManager__drawMessage() {
	static const SRwRect stRect = { 95.0f, 99.0f, 95.0f, 59.0f };

	__asm {
		add		esp, 8
		mov		edi, ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		shr		edi, 1
		mov		[esp+20h-18h], edi
		fild	dword ptr [esp+20h-18h]
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fmul	fWideScreenHeightScaleDown
		fld		st
		fmul	dword ptr stRect.m_fBottom
		fadd	st, st(2)
		fstp	dword ptr [esp+20h-4]
		fmul	dword ptr stRect.m_fTop
		fsubp	st(1), st
		fstp	dword ptr [esp+20h-0Ch]
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fld		st
		fmul	fWideScreenWidthScaleDown
		fld		st
		fmul	dword ptr stRect.m_fLeft
		fstp	dword ptr [esp+20h-10h]
		fmul	dword ptr stRect.m_fRight
		fsubp	st(1), st
		fstp	dword ptr [esp+20h-8]
		mov		eax, ADDR_0057414D_CMenuManager__drawMessage
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_00574198_CMenuManager__drawMessage() {
	static const float fPosY = 89.0f;

	__asm {
		mov		[esp+20h-10h], edi
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fmul	fWideScreenHeightScaleDown
		fmul	fPosY
		fisubr	dword ptr [esp+20h-10h]
		fstp	dword ptr [esp+20h-14h]
		mov		edx, ADDR_005741D0_CMenuManager__drawMessage
		jmp		edx
	}
}

void __declspec(naked) HOOK_PTR_00574213_CMenuManager__drawMessage() {
	static const float fPosY = 24.0f;
	static const float fHeight = 9.0f;

	__asm {
		mov		[esp+20h-10h], edi
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fmul	fWideScreenHeightScaleDown
		fld		st
		fmul	fPosY
		fisubr	dword ptr [esp+20h-10h]
		fxch	st(1)
		fmul	fHeight
		mov		eax, ADDR_0057423F_CMenuManager__drawMessage
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_00574252_CMenuManager__drawMessage() {
	static const float fPosY = 34.0f;

	__asm {
		mov		[esp+20h-10h], edi
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fmul	fWideScreenHeightScaleDown
		fld		st
		fmul	fPosY
		fisubr	dword ptr [esp+20h-10h]
		mov		eax, ADDR_0057426A_CMenuManager__drawMessage
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_005746FE_CMenuManager__drawRadioStationSprites() {
	static const float fPosX = 44.0f;
	static const float fHalfSize = 17.5f;

	__asm {
		fld		fHalfSize
		fmul	fWideScreenWidthDiff
		fadd	fPosX
		fstp	dword ptr [esp+28h-18h]
		mov		eax, ADDR_00574706_CMenuManager__drawRadioStationSprites
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_0057471D_CMenuManager__drawRadioStationSprites() {
	static const float fPosY = 300.0f / SCREEN_RESOLUTION_HEIGHT;
	static const float fSize = 35.0f;
	static const float fHalfSize = 17.5f;

	__asm {
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fld		st
		fmul	fWideScreenHeightScaleDown
		fmul	fSize
		fstp	dword ptr [esp+28h-14h]
		fld		st
		//fmul	ds:ADDR_fScreenHeightScale
		fmul	fPosY
		fxch	st(1)
		fmul	fWideScreenHeightScaleMid
		fmul	fHalfSize
		faddp	st(1), st
		fstp	dword ptr [esp+28h-0Ch]
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fld		st
		fmul	fWideScreenWidthScaleDown
		fmul	fSize
		fstp	dword ptr [esp+28h-10h]
		fmul	ds:ADDR_fScreenWidthScale
		fmul	dword ptr [esp+28h-18h]
		fstp	dword ptr [esp+28h-8]
		mov		eax, ADDR_005747B2_CMenuManager__drawRadioStationSprites
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_005747E8_CMenuManager__drawRadioStationSprites() {
	static const float fPosX = 47.0f;

	__asm {
		fld		dword ptr [esp+28h-18h]
		fadd	fPosX
		fstp	dword ptr [esp+28h-18h]
		mov		eax, ADDR_005747EF_CMenuManager__drawRadioStationSprites
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_00574811_CMenuManager__drawRadioStationSprites() {
	static const float fPosY = 290.0f / SCREEN_RESOLUTION_HEIGHT;
	static const float fSize = 60.0f;
	static const float fHalfSize = 30.0f;

	__asm {
		movsx	edx, al
		imul	edx, 47
		sub		edx, 15
		mov		[esp+28h-14h], edx
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fld		st
		fmul	fWideScreenHeightScaleDown
		fmul	fSize
		fstp	dword ptr [esp+28h-8]
		fld		st
		//fmul	ds:ADDR_fScreenHeightScale
		fmul	fPosY
		fxch	st(1)
		fmul	fWideScreenHeightScaleMid
		fmul	fHalfSize
		faddp	st(1), st
		fstp	dword ptr [esp+28h-10h]
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fld		st
		fmul	fWideScreenWidthScaleDown
		fmul	fSize
		fstp	dword ptr [esp+28h-0Ch]
		fld		st
		fmul	ds:ADDR_fScreenWidthScale
		fimul	dword ptr [esp+28h-14h]
		fxch	st(1)
		fmul	fWideScreenWidthScaleMid
		fmul	fHalfSize
		faddp	st(1), st
		fstp	dword ptr [esp+28h-14h]
		mov		eax, ADDR_005748B6_CMenuManager__drawRadioStationSprites
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_0057495C_CMenuManager__drawStats() {
	static const float fWidth = 0.3f;
	static const float fHeight = 0.75f;

	__asm {
		add		esp, 4
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fmul	fWideScreenHeightScaleDown
		fmul	fHeight
		fstp	dword ptr [esp+0A4h-0A0h]
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fmul	fWideScreenWidthScaleDown
		fmul	fWidth
		fstp	dword ptr [esp+0A4h-0A4h]
		mov		eax, ADDR_005749B9_CMenuManager__drawStats
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_00574EB4_CMenuManager__drawStats() {
	static const float fWidth = 50.0f;

	__asm {
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fmul	fWideScreenWidthScaleDown
		fmul	fWidth
		fsubr	dword ptr [esp+9Ch-6Ch]
		mov		eax, ADDR_00574ED2_CMenuManager__drawStats
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_00574FD1_CMenuManager__drawStats() {
	static const float fWidth = 0.6f;
	static const float fHeight = 0.8f;

	__asm {
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fmul	fWideScreenHeightScaleDown
		fmul	fHeight
		fstp	dword ptr [esp+0A4h-0A0h]
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fmul	fWideScreenWidthScaleDown
		fmul	fWidth
		fstp	dword ptr [esp+0A4h-0A4h]
		mov		eax, ADDR_00575023_CMenuManager__drawStats
		jmp		eax
	}
}
/*
void __declspec(naked) HOOK_PTR_00575B6A_CMenuManager__drawMap() {
	static const float fWidth = 4.0f;
	static const float fHeight = 4.0f;

	__asm {
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fmul	fWideScreenWidthScaleDown
		fmul	fWidth
		call	_ftol2
		mov		[esp+64h-51h], al
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fmul	fWideScreenHeightScaleDown
		fmul	fHeight
		mov		eax, ADDR_00575BB3_CMenuManager__drawMap
		jmp		eax
	}
}
*/
void __declspec(naked) HOOK_PTR_00575E96_CMenuManager__drawMap() {
	static const float fWidth = 0.8f;
	static const float fHeight = 0.8f;

	__asm {
		sub		esp, 4
		mov		ebp, SCREEN_RESOLUTION_MINHEIGHT
		mov		esi, SCREEN_RESOLUTION_MINWIDTH
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fmul	fWideScreenHeightScaleDown
		fmul	fHeight
		fstp	dword ptr [esp+6Ch-68h]
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fmul	fWideScreenWidthScaleDown
		fmul	fWidth
		fstp	dword ptr [esp+6Ch-6Ch]
		mov		eax, ADDR_00575EF3_CMenuManager__drawMap
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_005760FD_CMenuManager__drawMap() {
	static const float fWidth = 0.3f;
	static const float fHeight = 0.55f;

	__asm {
		add		esp, 4
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fmul	fWideScreenHeightScaleDown
		fmul	fHeight
		fstp	dword ptr [esp+6Ch-68h]
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fmul	fWideScreenWidthScaleDown
		fmul	fWidth
		fstp	dword ptr [esp+6Ch-6Ch]
		mov		eax, ADDR_0057614F_CMenuManager__drawMap
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_00576379_CMenuManager__drawBriefs() {
	static const float fWidth = 0.49f;
	static const float fHeight = 0.70f;

	__asm {
		add		esp, 4
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fmul	fWideScreenHeightScaleDown
		fmul	fHeight
		fstp	dword ptr [esp+34h-30h]
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fmul	fWideScreenWidthScaleDown
		fmul	fWidth
		fstp	dword ptr [esp+34h-34h]
		mov		eax, ADDR_005763D4_CMenuManager__drawBriefs
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_0057657C_CMenuManager__drawBriefs() {
	static const float fPosX = 50.0f / SCREEN_RESOLUTION_WIDTH;
	static const float fPosY = 105.0f / SCREEN_RESOLUTION_HEIGHT;
	static const float fHalfSize = 5.0f;

	__asm {
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fld		st
		fmul	fWideScreenHeightScaleDown
		fmul	fHalfSize
		fxch	st(1)
		//fmul	ds:ADDR_fScreenHeightScale
		fmul	fPosY
		fld		st
		fadd	st, st(2)
		fst		dword ptr [esp+2Ch-1Ch]
		fstp	dword ptr [esp+2Ch-24h]
		fsubrp	st(1), st
		fst		dword ptr [esp+2Ch-14h]
		fstp	dword ptr [esp+2Ch-0Ch]
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fld		st
		//fmul	ds:ADDR_fScreenWidthScale
		fmul	fPosX
		fxch	st(1)
		fmul	fWideScreenWidthScaleDown
		fmul	fHalfSize
		fld		st
		fadd	st, st(2)
		fstp	dword ptr [esp+2Ch-20h]
		fsubr	st, st(1)
		fstp	dword ptr [esp+2Ch-18h]
		fst		dword ptr [esp+2Ch-10h]
		mov		eax, ADDR_0057668F_CMenuManager__drawBriefs
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_005766EB_CMenuManager__drawBriefs() {
	static const float fPosX = 50.0f / SCREEN_RESOLUTION_WIDTH;
	static const float fPosY = 343.0f / SCREEN_RESOLUTION_HEIGHT;
	static const float fHalfSize = 5.0f;

	__asm {
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fld		st
		fmul	fWideScreenHeightScaleDown
		fmul	fHalfSize
		fxch	st(1)
		//fmul	ds:ADDR_fScreenHeightScale
		fmul	fPosY
		fld		st
		fadd	st, st(2)
		fst		dword ptr [esp+2Ch-8]
		fstp	dword ptr [esp+2Ch-10h]
		fsubrp	st(1), st
		fst		dword ptr [esp+2Ch-18h]
		fstp	dword ptr [esp+2Ch-20h]
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fld		st
		fmul	fWideScreenWidthScaleDown
		fmul	fHalfSize
		fxch	st(1)
		//fmul	ds:ADDR_fScreenWidthScale
		fmul	fPosX
		fst		dword ptr [esp+2Ch-0Ch]
		fst		dword ptr [esp+2Ch-14h]
		fld		st
		fadd	st, st(2)
		fstp	dword ptr [esp+2Ch-1Ch]
		fsubrp	st(1), st
		mov		eax, ADDR_005767FE_CMenuManager__drawBriefs
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_00576955_CMenuManager__drawEntryBars() {
	static const float fSize = 2.0f;

	__asm {
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fmul	fWideScreenHeightScaleDown
		fmul	fSize
		fld		st
		fadd	st, st(2)
		fadd	dword ptr [esp+48h+8]
		fsub	dword ptr [esp+48h-34h]
		fstp	dword ptr [esp+48h-14h]
		faddp	st(1), st
		fadd	dword ptr [esp+48h+8]
		fstp	dword ptr [esp+48h-1Ch]
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fmul	fWideScreenWidthScaleDown
		fmul	fSize
		fld		st
		fadd	dword ptr [esp+48h-30h]
		fadd	dword ptr [esp+48h-40h]
		fstp	dword ptr [esp+48h-18h]
		lea		ecx, [esp+48h-24h]
		mov		eax, ADDR_005769EF_CMenuManager__drawEntryBars
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_00578FFC_CMenuManager__drawWindowText() {
	static const float fWidth = 0.7f;
	//static const float fHeight = 1.0f;

	__asm {
		add		esp, 4
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fmul	fWideScreenHeightScaleDown
		//fmul	fHeight
		fstp	dword ptr [esp+30h-2Ch]
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fmul	fWideScreenWidthScaleDown
		fmul	fWidth
		fstp	dword ptr [esp+30h-30h]
		mov		eax, ADDR_00579055_CMenuManager__drawWindowText
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_00579081_CMenuManager__drawWindowText() {
	static const float fPosX = 4.0f;
	static const float fPosY = 22.0f;

	__asm {
		add		esp, 10h
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fmul	fWideScreenWidthScaleDown
		fmul	fPosX
		fsubr	dword ptr [esp+28h-10h]
		fstp	dword ptr [esp+28h-10h]
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fmul	fWideScreenHeightScaleDown
		fmul	fPosY
		mov		eax, ADDR_005790B2_CMenuManager__drawWindowText
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_005790D4_CMenuManager__drawWindowText() {
	__asm {
		mov		eax, ADDR_drawRect
		call	eax
		add		esp, 8
		test	esi, esi
		jz		text_available
		cmp		byte ptr [esi], 0
		jz		text_available
		mov		ecx, ADDR_005792A8_CMenuManager__drawWindowText
		jmp		ecx
text_available:
		mov		edx, ADDR_005790DC_CMenuManager__drawWindowText
		jmp		edx
	}
}

void __declspec(naked) HOOK_PTR_00579316_CMenuManager__drawWindowText() {
	__asm {
		add		esp, 0Ch
		mov		eax, ADDR_005790DC_CMenuManager__drawWindowText
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_00579591_CMenuManager__drawEntries() {
	static const float fWidth = 1.3f;
	static const float fHeight = 2.1f;

	__asm {
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fmul	fWideScreenHeightScaleDown
		fmul	fHeight
		fstp	dword ptr [esp+130h-12Ch]
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fmul	fWideScreenWidthScaleDown
		fmul	fWidth
		fstp	dword ptr [esp+130h-130h]
		mov		eax, ADDR_005795E3_CMenuManager__drawEntries
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_005796DA_CMenuManager__drawEntries() {
	static const float fWidth = 0.49f;
	static const float fHeight = 1.2f;

	__asm {
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fmul	fWideScreenHeightScaleDown
		fmul	fHeight
		fstp	dword ptr [esp+130h-12Ch]
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fmul	fWideScreenWidthScaleDown
		fmul	fWidth
		fstp	dword ptr [esp+130h-130h]
		mov		eax, ADDR_0057972C_CMenuManager__drawEntries
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_00579936_CMenuManager__drawEntries() {
	static const float fWidth = 0.42f;
	static const float fHeight = 0.95f;

	__asm {
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fmul	fWideScreenHeightScaleDown
		fmul	fHeight
		fstp	dword ptr [esp+130h-12Ch]
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fmul	fWideScreenWidthScaleDown
		fmul	fWidth
		fstp	dword ptr [esp+130h-130h]
		mov		eax, ADDR_00579998_CMenuManager__drawEntries
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_005799B3_CMenuManager__drawEntries() {
	static const float fWidth = 0.7f;
	//static const float fHeight = 1.0f;

	__asm {
		sub		esp, 4
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fmul	fWideScreenHeightScaleDown
		//fmul	fHeight
		fstp	dword ptr [esp+130h-12Ch]
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fmul	fWideScreenWidthScaleDown
		fmul	fWidth
		fstp	dword ptr [esp+130h-130h]
		mov		eax, ADDR_00579A1E_CMenuManager__drawEntries
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_00579CA8_CMenuManager__drawEntries() {
	static const float fPosX = 40.0f;

	__asm {
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fmul	fWideScreenWidthScaleUp
		fmul	fPosX
		mov		eax, ADDR_00579CCA_CMenuManager__drawEntries
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_0057A244_CMenuManager__drawEntries() {
	static const float fWidth = 0.35f;
	static const float fHeight = 0.95f;

	__asm {
		sub		esp, 8
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fmul	fWideScreenHeightScaleDown
		fmul	fHeight
		fstp	dword ptr [esp+130h-12Ch]
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fmul	fWideScreenWidthScaleDown
		fmul	fWidth
		fstp	dword ptr [esp+130h-130h]
		mov		eax, ADDR_0057A385_CMenuManager__drawEntries
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_0057A2C0_CMenuManager__drawEntries() {
	static const float fWidth = 0.56f;
	//static const float fHeight = 1.0f;

	__asm {
		sub		esp, 8
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fmul	fWideScreenHeightScaleDown
		//fmul	fHeight
		fstp	dword ptr [esp+130h-12Ch]
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fmul	fWideScreenWidthScaleDown
		fmul	fWidth
		fstp	dword ptr [esp+130h-130h]
		mov		eax, ADDR_0057A385_CMenuManager__drawEntries
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_0057A32A_CMenuManager__drawEntries() {
	static const float fWidth = 0.7f;
	//static const float fHeight = 1.0f;

	__asm {
		sub		esp, 8
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fmul	fWideScreenHeightScaleDown
		//fmul	fHeight
		fstp	dword ptr [esp+130h-12Ch]
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fmul	fWideScreenWidthScaleDown
		fmul	fWidth
		fstp	dword ptr [esp+130h-130h]
		mov		eax, ADDR_0057A385_CMenuManager__drawEntries
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_0057A45C_CMenuManager__drawEntries() {
	static const float fPosX = 40.0f;

	__asm {
		push	ebx
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fmul	fWideScreenWidthScaleDown
		fmul	fPosX
		mov		ebx, ADDR_0057A461_CMenuManager__drawEntries
		jmp		ebx
	}
}

void __declspec(naked) HOOK_PTR_0057A55B_CMenuManager__drawEntries() {
	static const float fPosY = 2.5f;
	static const float fWidth = 32.0f;
	static const float fHeight = 47.0f;

	__asm {
		fstp	dword ptr [esp+130h-70h]
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fmul	fWideScreenHeightScaleDown
		fld		st
		fimul	dword ptr [esp+130h-11Ch]
		fxch	st(1)
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fmul	fWideScreenWidthScaleDown
		fld		st(1)
		fmul	fPosY
		fsubr	st, st(3)
		fstp	dword ptr [esp+130h-64h]
		fmul	fWidth
		fadd	dword ptr [esp+130h-70h]
		fstp	dword ptr [esp+130h-68h]
		fmul	fHeight
		faddp	st(1), st
		mov		eax, ADDR_0057A5B6_CMenuManager__drawEntries
		jmp		eax
	}
}

void __declspec(naked) CODE_0_CMenuManager__drawEntries() {
	static const int iMaxBrightness = 384;
	static const float fBrightnessScale = 1.0f / 384;
	static const float fPosY = 125.0f;

	__asm {
		fild	[ebp]CMenuManager.m_iBrightness
		fmul	fBrightnessScale
		fld		fPosY
		jmp		CODE_5_CMenuManager__drawEntries
	}
}

void __declspec(naked) CODE_1_CMenuManager__drawEntries() {
	static const char cMaxRadioVolume = 64;
	static const float fRadioVolumeScale = 1.0f / 64;
	static const float fPosY = 95.0f;

	__asm {
		movsx	eax, [ebp]CMenuManager.m_cRadioVolume
		mov		[esp+130h-11Ch], eax
		fild	dword ptr [esp+130h-11Ch]
		fmul	fRadioVolumeScale
		fld		fPosY
		jmp		CODE_5_CMenuManager__drawEntries
	}
}

void __declspec(naked) CODE_2_CMenuManager__drawEntries() {
	static const char cMaxSfxVolume = 64;
	static const float fSfxVolumeScale = 1.0f / 64;
	static const float fPosY = 125.0f;

	__asm {
		movsx	eax, [ebp]CMenuManager.m_cSfxVolume
		mov		[esp+130h-11Ch], eax
		fild	dword ptr [esp+130h-11Ch]
		fmul	fSfxVolumeScale
		fld		fPosY
		jmp		CODE_5_CMenuManager__drawEntries
	}
}

void __declspec(naked) CODE_3_CMenuManager__drawEntries() {
	static const float fMinDrawDistance = 0.925f;
	static const float fMaxDrawDistance = 1.8f;
	static const float fDrawDistanceScale = 1.0f / (1.8f - 0.925f);
	static const float fPosY = 125.0f;

	__asm {
		fld		[ebp]CMenuManager.m_fDrawDistance
		fsub	fMinDrawDistance
		fmul	fDrawDistanceScale
		fld		fPosY
		jmp		CODE_5_CMenuManager__drawEntries
	}
}

void __declspec(naked) CODE_4_CMenuManager__drawEntries() {
	static const float fMinMouseSensivity = 0.0003125f;
	static const float fMaxMouseSensivity = 0.005f;
	static const float fMouseSensivityScale = 1.0f / (0.005f - 0.0003125f);
	static const float fPosY = 125.0f;

	__asm {
		fld		ds:ADDR_fMouseSensivity
		fsub	fMinMouseSensivity
		fmul	fMouseSensivityScale
		fld		fPosY
		jmp		CODE_5_CMenuManager__drawEntries
	}
}

void __declspec(naked) CODE_5_CMenuManager__drawEntries() {
	static const float fPosX = 40.0f / SCREEN_RESOLUTION_WIDTH;
	static const float fStartHeight = 4.0f;
	static const float fEndHeight = 20.0f;
	static const float fTotalWidth = 100.0f;
	static const float fWidth = 3.0f;

	__asm {
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fld		st
		fmul	fWideScreenHeightScaleDown
		fld		st
		fmul	fEndHeight
		fstp	dword ptr [esp+130h-0BCh]
		fmul	fStartHeight
		fstp	dword ptr [esp+130h-0B4h]
		mov		eax, ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		cmp		eax, SCREEN_RESOLUTION_MINHEIGHT
		jnz		do_ypos_scaling
		fstp	st
		jmp		no_ypos_scaling
do_ypos_scaling:
		fmul	ds:ADDR_fScreenHeightScale
		fmulp	st(1), st
no_ypos_scaling:
		fstp	dword ptr [esp+130h-0ACh]
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fld		st
		fmul	fWideScreenWidthScaleDown
		fld		st
		fmul	fTotalWidth
		fstp	dword ptr [esp+130h-0C4h]
		fmul	fWidth
		fst		dword ptr [esp+130h-124h]
		fxch	st(1)
		fld		st
		//fmul	ds:ADDR_fScreenWidthScale
		fmul	fPosX
		fsubp	st(1), st
		fsub	dword ptr [esp+130h-0C4h]
		fstp	dword ptr [esp+130h-108h]
		call	_ftol2
		mov		ecx, ADDR_0057B0FF_CMenuManager__drawEntries
		jmp		ecx
	}
}

void __declspec(naked) HOOK_PTR_0057B144_CMenuManager__drawEntries() {
	static const float fHeight = 25.0f;

	__asm {
		fld		dword ptr [esp+130h-0ACh]
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fmul	fWideScreenHeightScaleDown
		fmul	fHeight
		fadd	st, st(1)
		call	_ftol2
		push	eax
		call	_ftol2
		push	eax
		fild	dword ptr [esp+138h-120h]
		fsub	dword ptr [esp+138h-124h]
		mov		eax, ADDR_0057B180_CMenuManager__drawEntries
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_0057B1A2_CMenuManager__drawEntries() {
	__asm {
		sub		esp, 10h
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		call	_ftol2
		mov		[esp+140h-13Ch], eax
		fild	dword ptr [esp+140h-120h]
		fadd	dword ptr [esp+140h-124h]
		call	_ftol2
		mov		[esp+140h-140h], eax
		mov		eax, ADDR_0057B1F3_CMenuManager__drawEntries
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_0057B215_CMenuManager__drawEntries() {
	__asm {
		fld		dword ptr [esp+130h-108h]
		fucompp
		mov		eax, ADDR_0057B222_CMenuManager__drawEntries
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_0057B9C0_CMenuManager__drawPage() {
	__asm {
		add		esp, 8
		movzx	eax, ds:[ADDR_clMenuManager]CMenuManager.m_eFrontend
		sub		eax, 0Dh
		cmp		eax, 6
		ja		no_frontend_texture
		mov		ecx, ds:ADDR_0057C274_CMenuManager__drawPage[eax*4]
		jmp		ecx
no_frontend_texture:
		mov		edx, ADDR_0057BA02_CMenuManager__drawPage
		jmp		edx
	}
}

void __declspec(naked) CODE_0_CMenuManager__drawPage() {
	static const float fSize = 256.0f;

	__asm {
		mov		dword ptr [esp+40h-14h], 0
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fld		st
		fst		dword ptr [esp+40h-18h]
		fmul	fWideScreenWidthScaleDown
		fmul	fSize
		fsubp	st(1), st
		fstp	dword ptr [esp+40h-20h]
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fmul	fWideScreenHeightScaleDown
		fmul	fSize
		fstp	dword ptr [esp+40h-1Ch]
		mov		eax, ADDR_0057B9CC_CMenuManager__drawPage
		jmp		eax
	}
}

void __declspec(naked) CODE_1_CMenuManager__drawPage() {
	static const float fSize = 256.0f;
	static const float fHalfSize = 128.0f;

	__asm {
		mov		dword ptr [esp+40h-14h], 0
		shr		edi, 1
		mov		[esp+40h-2Ch], edi
		fild	dword ptr [esp+40h-2Ch]
		fld		st
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fmul	fWideScreenWidthScaleDown
		fmul	fHalfSize
		fld		st
		fadd	st, st(2)
		fstp	dword ptr [esp+40h-18h]
		fsubp	st(1), st
		fstp	dword ptr [esp+40h-20h]
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fmul	fWideScreenHeightScaleDown
		fmul	fSize
		fstp	dword ptr [esp+40h-1Ch]
		mov		ecx, ADDR_0057B9CC_CMenuManager__drawPage
		jmp		ecx
	}
}

void __declspec(naked) CODE_2_CMenuManager__drawPage() {
	static const float fWidth = 300.0f;
	static const float fHeight = 200.0f;

	__asm {
		mov		dword ptr [esp+40h-14h], 0
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fld		st
		fst		dword ptr [esp+40h-18h]
		fmul	fWideScreenWidthScaleDown
		fmul	fWidth
		fsubp	st(1), st
		fstp	dword ptr [esp+40h-20h]
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fmul	fWideScreenHeightScaleDown
		fmul	fHeight
		fstp	dword ptr [esp+40h-1Ch]
		mov		eax, ADDR_0057B9CC_CMenuManager__drawPage
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_0057BCD3_CMenuManager__drawPage() {
	static const float fPosY = 23.5f;
	static const float fWidth = 52.5f;
	static const float fHeight = 2.5f;

	__asm {
		shr		ecx, 1
		mov		[esp+40h-28h], ecx
		mov		eax, ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		shr		eax, 1
		mov		[esp+40h-2Ch], eax
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fld		st
		fmul	fWideScreenHeightScaleDown
		fmul	fHeight
		fxch	st(1)
		fmul	fWideScreenHeightScaleDown
		fmul	fPosY
		fiadd	dword ptr [esp+40h-28h]
		fld		st
		fadd	st, st(2)
		fxch	st(1)
		fsubrp	st(2), st
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fmul	fWideScreenWidthScaleDown
		fmul	fWidth
		fild	dword ptr [esp+40h-2Ch]
		fld		st
		fadd	st, st(2)
		fxch	st(1)
		fsubrp	st(2), st
		mov		edx, ADDR_0057BD46_CMenuManager__drawPage
		jmp		edx
	}
}

void __declspec(naked) HOOK_PTR_0057BD75_CMenuManager__drawPage() {
	static const float fPosY = 23.5f;
	static const float fSize = 2.5f;

	__asm {
		add		esp, 8
		mov		edx, SCREEN_RESOLUTION_MINWIDTH / 2
		mov		eax, ds:ADDR_iUTraxScanPosX
		sub		edx, eax
		mov		[esp+40h-30h], edx
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fld		st
		fmul	fWideScreenHeightScaleDown
		fmul	fSize
		fxch	st(1)
		fmul	fWideScreenHeightScaleDown
		fmul	fPosY
		fiadd	dword ptr [esp+40h-28h]
		fld		st
		fadd	st, st(2)
		fxch	st(1)
		fsubrp	st(2), st
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fld		st
		fmul	fWideScreenWidthScaleDown
		fmul	fSize
		fxch	st(1)
		fmul	fWideScreenWidthScaleDown
		fimul	dword ptr [esp+40h-30h]
		fisubr	dword ptr [esp+40h-2Ch]
		fld		st
		fadd	st, st(2)
		fxch	st(1)
		fsubrp	st(2), st
		mov		ecx, ADDR_0057BDF8_CMenuManager__drawPage
		jmp		ecx
	}
}

void __declspec(naked) HOOK_PTR_0057C043_CMenuManager__drawPage() {
	__asm {
		lea		edi, [esi]CMenuManager.m_apstTextures+60h
		jmp		CODE_3_CMenuManager__drawPage
	}
}

void __declspec(naked) HOOK_PTR_0057C135_CMenuManager__drawPage() {
	__asm {
		lea		edi, [esi]CMenuManager.m_apstTextures+5Ch
		jmp		CODE_3_CMenuManager__drawPage
	}
}

void __declspec(naked) CODE_3_CMenuManager__drawPage() {
	static const SRwRect stRwRectOffset = { 6.0f, 21.0f, 24.0f, 3.0f };

	__asm {
		fild	[esi]CMenuManager.m_iMousePosX
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fmul	fWideScreenWidthScaleDown
		fld		st
		fmul	dword ptr stRwRectOffset.m_fRight
		fadd	st, st(2)
		fstp	dword ptr [esp+40h-8]
		fmul	dword ptr stRwRectOffset.m_fLeft
		faddp	st(1), st
		fstp	dword ptr [esp+40h-10h]
		fild	[esi]CMenuManager.m_iMousePosY
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fmul	fWideScreenHeightScaleDown
		fld		st
		fmul	dword ptr stRwRectOffset.m_fBottom
		fadd	st, st(2)
		fstp	dword ptr [esp+40h-4]
		fmul	dword ptr stRwRectOffset.m_fTop
		faddp	st(1), st
		mov		eax, ADDR_0057C18F_CMenuManager__drawPage
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_0057C1BD_CMenuManager__drawPage() {
	static const float fSize = 18.0f;

	__asm {
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fmul	fWideScreenWidthScaleDown
		fmul	fSize
		fadd	st, st(1)
		fstp	dword ptr [esp+40h-8]
		fstp	dword ptr [esp+40h-10h]
		fild	[esi]CMenuManager.m_iMousePosY
		fst		dword ptr [esp+40h-4]
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fmul	fWideScreenHeightScaleDown
		fmul	fSize
		faddp	st(1), st
		mov		eax, ADDR_0057C1F5_CMenuManager__drawPage
		jmp		eax
	}
}

void __declspec(naked) CODE_0_CMenuManager__updateEntrySetting() {
	__asm {
		mov		eax, [esi]CMenuManager.m_eRadarMode
		movsx	ecx, byte ptr [esp+0Ch+4]
		add		eax, ecx
		mov		[esi]CMenuManager.m_eRadarMode, eax
		jns		not_radar_mode_none
		mov		[esi]CMenuManager.m_eRadarMode, MENU_RADAR_NONE
		jmp		not_radar_mode_both
not_radar_mode_none:
		cmp		[esi]CMenuManager.m_eRadarMode, MENU_RADAR_NONE
		jle		not_radar_mode_both
		mov		[esi]CMenuManager.m_eRadarMode, MENU_RADAR_BOTH
not_radar_mode_both:
		mov		edx, ADDR_0057D438_CMenuManager__updateEntrySetting
		jmp		edx
	}
}

void __declspec(naked) CODE_1_CMenuManager__updateEntrySetting() {
	__asm {
		mov		eax, ds:[ADDR_clParticle]CParticle.m_eQuality
		movsx	ecx, byte ptr [esp+0Ch+4]
		add		eax, ecx
		mov		ds:[ADDR_clParticle]CParticle.m_eQuality, eax
		jns		not_fx_quality_very_high
		mov		ds:[ADDR_clParticle]CParticle.m_eQuality, FX_QUALITY_VERY_HIGH
		jmp		not_fx_quality_low
not_fx_quality_very_high:
		cmp		ds:[ADDR_clParticle]CParticle.m_eQuality, FX_QUALITY_VERY_HIGH
		jle		not_fx_quality_low
		mov		ds:[ADDR_clParticle]CParticle.m_eQuality, FX_QUALITY_LOW
not_fx_quality_low:
		mov		edx, ADDR_0057D438_CMenuManager__updateEntrySetting
		jmp		edx
	}
}

void __declspec(naked) HOOK_PTR_0057D8E9_CMenuManager__drawDebugInputs() {
	static const float fFootCtrlHeight = (28 * 11.0f) / 25;
	static const float fMousePlusKeyboardCtrlHeight = (28 * 11.0f) / 22;
	static const float fJoypadCtrlHeight = 11.0f;

	__asm {
		mov		[esp+20h+4], eax
		fild	dword ptr [esp+20h+4]
		test	ecx, ecx
		jz		car_controls
		dec		ecx
		jnz		undefined_controls
		mov		[esp+20h-14h], 25
		fld		fFootCtrlHeight
		jmp		not_using_joypad
car_controls:
		mov		dl, [edi]CMenuManager.m_bUsingJoypad
		test	dl, dl
		jnz		using_joypad
		mov		[esp+20h-14h], 22
		fld		fMousePlusKeyboardCtrlHeight
		jmp		not_using_joypad
using_joypad:
		mov		[esp+20h-14h], 28
		fld		fJoypadCtrlHeight
not_using_joypad:
		fstp	dword ptr [esp+20h-0Ch]
		jmp		defined_controls
undefined_controls:
		mov		[esp+20h-14h], ebp
		fst		dword ptr [esp+20h-0Ch]
defined_controls:
		fstp	dword ptr [esp+20h+4]
		mov		eax, ADDR_0057D937_CMenuManager__drawDebugInputs
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_0057DA79_CMenuManager__drawDebugInputs() {
	__asm {
		inc		ebp
		fld		dword ptr [esp+24h+4]
		fadd	dword ptr [esp+24h-0Ch]
		fstp	dword ptr [esp+24h+4]
		mov		eax, [esp+24h-14h]
		cmp		ebp, eax
		mov		ecx, ADDR_0057DA8E_CMenuManager__drawDebugInputs
		jmp		ecx
	}
}

void __declspec(naked) HOOK_PTR_0057E250_CMenuManager__drawBottomMessage() {
	static const float fWidth = 0.4f;
	static const float fHeight = 0.6f;
	static const float fHeightMap = 0.5f;

	__asm {
		jz		menu_map_page
		fld		fHeight
		jmp		not_menu_map_page
menu_map_page:
		fld		fHeightMap
not_menu_map_page:
		sub		esp, 8
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fmul	fWideScreenHeightScaleDown
		fmulp	st(1), st
		fstp	dword ptr [esp+10h-0Ch]
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fmul	fWideScreenWidthScaleDown
		fmul	fWidth
		fstp	dword ptr [esp+10h-10h]
		mov		eax, ADDR_0057E277_CMenuManager__drawBottomMessage
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_0057E734_CMenuManager__drawInputs() {
	static const float fFootCtrlHeight = (28 * 11.0f) / 25;
	static const float fMousePlusKeyboardCtrlHeight = (28 * 11.0f) / 22;
	static const float fJoypadCtrlHeight = 11.0f;

	__asm {
		fstp	dword ptr [esp+64h-4Ch]
		movzx	eax, [edi]CMenuManager.m_bCarControls
		test	eax, eax
		jz		car_controls
		dec		eax
		jnz		undefined_controls
		mov		bl, 25
		fld		fFootCtrlHeight
		jmp		not_using_joypad
car_controls:
		mov		al, [edi]CMenuManager.m_bUsingJoypad
		test	al, al
		jnz		using_joypad
		mov		bl, 22
		fld		fMousePlusKeyboardCtrlHeight
		jmp		not_using_joypad
using_joypad:
		mov		bl, 28
		fld		fJoypadCtrlHeight
not_using_joypad:
		fstp	dword ptr [esp+64h-34h]
		mov		ecx, ADDR_0057E768_CMenuManager__drawInputs
		jmp		ecx
undefined_controls:
		mov		edx, ADDR_0057E764_CMenuManager__drawInputs
		jmp		edx
	}
}

void __declspec(naked) HOOK_PTR_0057EA24_CMenuManager__drawInputs() {
	static const float fHeight = 11.0f;
	static const SRwRect stRect = { 260.0f / SCREEN_RESOLUTION_WIDTH, 0.0f, 620.0f / SCREEN_RESOLUTION_WIDTH, 0.0f };

	__asm {
		mov		[esp+64h-38h], ebp
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fmul	ds:ADDR_fScreenHeightScale
		fild	dword ptr [esp+64h-38h]
		fmul	dword ptr [esp+64h-34h]
		fadd	dword ptr [esp+64h-44h]
		fmulp	st(1), st
		fst		dword ptr [esp+64h-0Ch]
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fmul	fWideScreenHeightScaleDown
		fmul	fHeight
		faddp	st(1), st
		fstp	dword ptr [esp+64h-4]
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		//fmul	ds:ADDR_fScreenWidthScale
		fld		st
		fmul	dword ptr stRect.m_fRight
		fstp	dword ptr [esp+64h-8]
		fmul	dword ptr stRect.m_fLeft
		fstp	dword ptr [esp+64h-10h]
		mov		eax, ADDR_0057EAA8_CMenuManager__drawInputs
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_0057EB0E_CMenuManager__drawInputs() {
	static const float fWidth = 0.3f;
	static const float fHeight = 0.6f;

	__asm {
		sub		esp, 4
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fmul	fWideScreenHeightScaleDown
		fmul	fHeight
		fstp	dword ptr [esp+06Ch-068h]
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fmul	fWideScreenWidthScaleDown
		fmul	fWidth
		mov		eax, ADDR_0057EB2E_CMenuManager__drawInputs
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_0057EDB9_CMenuManager__drawInputs() {
	__asm {
		inc		ebp
		mov		[esp+64h-38h], ebp
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fmul	ds:ADDR_fScreenHeightScale
		fild	dword ptr [esp+64h-38h]
		fmul	dword ptr [esp+64h-34h]
		fadd	dword ptr [esp+64h-44h]
		fmulp	st(1), st
		fstp	dword ptr [esp+64h-4Ch]
		mov		eax, ADDR_0057EDE3_CMenuManager__drawInputs
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_0057EFE8_CMenuManager__processController() {
	__asm {
		mov		[esi]CMenuManager.m_bCursorShown, 0
		mov		eax, [esi]CMenuManager.m_eEntryAction
		cmp		eax, MENU_ACTION_GOBACK
		jz		go_back
		mov		ecx, [esp+4+8]
		jmp		go_next
go_back:
		mov		ecx, [esp+4+0Ch]
go_next:
		mov		byte ptr [ecx], 1
		mov		edx, ADDR_0057EFF6_CMenuManager__processController
		jmp		edx
	}
}

void __declspec(naked) HOOK_PTR_0057F235_CMenuManager__processController() {
	__asm {
		mov		al, [esi]CMenuManager.m_bCursorShown
		test	al, al
		jz		mouse_not_shown
		mov		ecx, ADDR_0057F23C_CMenuManager__processController
		jmp		ecx
mouse_not_shown:
		mov		edx, ADDR_0057F2A3_CMenuManager__processController
		jmp		edx
	}
}

void __declspec(naked) HOOK_PTR_0057F2A3_CMenuManager__processController() {
	__asm {
		mov		eax, [esi]CMenuManager.m_iSelectedInput
		mov		ecx, [esi]CMenuManager.m_iLastSelectedEntry
		cmp		eax, ecx
		jz		do_not_play_frontend_sound
		mov		[esi]CMenuManager.m_iLastSelectedEntry, eax
		push	3F800000h
		push	0
		push	SOUND_FRONTEND_UPDOWN
		mov		ecx, ADDR_clAudioManager
		mov		edx, ADDR_CAudioManager__playFrontendSound
		call	edx
do_not_play_frontend_sound:
		cmp		byte ptr [edi], 0
		pop		edi
		jz		do_not_process_inputs
		mov		ecx, ADDR_0057F2A9_CMenuManager__processController
		jmp		ecx
do_not_process_inputs:
		mov		edx, ADDR_0057F2F7_CMenuManager__processController
		jmp		edx
	}
}

void __declspec(naked) HOOK_PTR_0057F693_CMenuManager__drawControls() {
	static const float fWidth = 0.9f;
	static const float fHeight = 1.7f;

	__asm {
		sub		esp, 4
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fmul	fWideScreenHeightScaleDown
		fmul	fHeight
		fstp	dword ptr [esp+0E4h-0E0h]
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fmul	fWideScreenWidthScaleDown
		fmul	fWidth
		mov		eax, ADDR_0057F6B3_CMenuManager__drawControls
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_0057F794_CMenuManager__drawControls() {
	static const float fHeight = (28 * 11.0f) / 25;

	__asm {
		mov		[esp+0DCh-0C4h], 25
		fld		fHeight
		fstp	dword ptr [esp+0DCh-0C8h]
		mov		eax, ADDR_0057F7E9_CMenuManager__drawControls
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_0057F7DB_CMenuManager__drawControls() {
	static const float fMousePlusKeyboardCtrlHeight = (28 * 11.0f) / 22;
	static const float fJoypadCtrlHeight = 11.0f;

	__asm {
		jnz		using_joypad
		mov		[esp+0DCh-0C4h], 22
		fld		fMousePlusKeyboardCtrlHeight
		jmp		not_using_joypad
using_joypad:
		mov		[esp+0DCh-0C4h], 28
		fld		fJoypadCtrlHeight
not_using_joypad:
		fstp	dword ptr [esp+0DCh-0C8h]
		mov		eax, ADDR_0057F7E9_CMenuManager__drawControls
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_0057F8C2_CMenuManager__drawControls() {
	__asm {
		mov		al, [esi]CMenuManager.m_bChangingInput
		test	al, al
		jnz		changing_input
		mov		cl, [esi]CMenuManager.m_bCursorShown
		test	cl, cl
		jz		cursor_not_shown
		mov		edx, ADDR_0057F8D0_CMenuManager__drawControls
		jmp		edx
cursor_not_shown:
		mov		eax, ADDR_0057F9AF_CMenuManager__drawControls
		jmp		eax
changing_input:
		mov		ecx, ADDR_0057F9E1_CMenuManager__drawControls
		jmp		ecx
	}
}

void __declspec(naked) HOOK_PTR_0057F91A_CMenuManager__drawControls() {
	static const float fPosY = 69.0f;

	__asm {
		movzx	eax, byte ptr [esp+0E8h-0CDh]
		mov		[esp+0E8h-0CCh], eax
		fild	[esi]CMenuManager.m_iMousePosY
		fstp	dword ptr [esp+0E8h-0D8h]
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fmul	ds:ADDR_fScreenHeightScale
		fld		dword ptr [esp+0E8h-0C8h]
		fimul	dword ptr [esp+0E8h-0CCh]
		fadd	fPosY
		fst		dword ptr [esp+0E8h-0CCh]
		fmul	st, st(1)
		fcomp	dword ptr [esp+0E8h-0D8h]
		fnstsw	ax
		test	ah, 5
		jp		mouse_out_of_selection
		fld		dword ptr [esp+0E8h-0CCh]
		fadd	dword ptr [esp+0E8h-0C8h]
		fmulp	st(1), st
		fcomp	dword ptr [esp+0E8h-0D8h]
		fnstsw	ax
		test	ah, 41h
		jnz		mouse_out_of_selection_no_pop
		mov		ecx, ADDR_0057F987_CMenuManager__drawControls
		jmp		ecx
mouse_out_of_selection:
		fstp	st
mouse_out_of_selection_no_pop:
		mov		edx, ADDR_0057F9AF_CMenuManager__drawControls
		jmp		edx
	}
}

void __declspec(naked) HOOK_PTR_0057FA18_CMenuManager__drawControls() {
	static const float fWidth = 0.4f;
	static const float fHeight = 0.6f;

	__asm {
		sub		esp, 4
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fmul	fWideScreenHeightScaleDown
		fmul	fHeight
		fstp	dword ptr [esp+0F0h-0ECh]
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fmul	fWideScreenWidthScaleDown
		fmul	fWidth
		mov		eax, ADDR_0057FA38_CMenuManager__drawControls
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_0057FA6F_CMenuManager__drawControls() {
	static const float fPosY = 69.0f;

	__asm {
		test	eax, eax
		jz		foot_controls
		dec		eax
		jnz		undefined_controls
		mov		ecx, ds:ADDR_aiCarCtrlIndices[ebx*4]
		jmp		car_controls
foot_controls:
		mov		ecx, ds:ADDR_aiFootCtrlIndices[ebx*4]
car_controls:
		mov		[esp+0E8h-0CCh], edi
		fild	dword ptr [esp+0E8h-0CCh]
		fmul	dword ptr [esp+0E8h-0C8h]
		fadd	fPosY
		mov		edx, ADDR_0057FAAD_CMenuManager__drawControls
		jmp		edx
undefined_controls:
		mov		eax, ADDR_0057FAD9_CMenuManager__drawControls
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_0057FAF3_CMenuManager__drawControls() {
	static const float fPosY = 410.0f;
	static const float fHeight = 23.0f;

	__asm {
		mov		al, [esi]CMenuManager.m_bChangingInput
		test	al, al
		jnz		changing_input
		mov		edx, [esi]CMenuManager.m_iSelectedInput
		test	edx, edx
		js		go_back
		mov		al, [esi]CMenuManager.m_bCursorShown
		test	al, al
		jz		cursor_not_shown
		fild	[esi]CMenuManager.m_iMousePosY
		fstp	dword ptr [esp+0E0h-0D8h]
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fld		st
		fmul	ds:ADDR_fScreenHeightScale
		fmul	fPosY
		fcom	dword ptr [esp+0E0h-0D8h]
		fnstsw	ax
		test	ah, 5
		jp		back_not_selected
		fxch	st(1)
		fmul	fWideScreenHeightScaleDown
		fmul	fHeight
		faddp	st(1), st
		fcom	dword ptr [esp+0E0h-0D8h]
		fnstsw	ax
		test	ah, 41h
		jnz		cursor_not_shown
		mov		[esi]CMenuManager.m_iSelectedInput, -1
go_back:
		mov		[esi]CMenuManager.m_eEntryAction, MENU_ACTION_GOBACK
		push	0FFh
		push	0F1h
		push	0CBh
		push	0ACh
		jmp		highlight_back
back_not_selected:
		fstp	st
		fstp	st
cursor_not_shown:
		mov		[esi]CMenuManager.m_eEntryAction, MENU_ACTION_GONEXT
changing_input:
		push	0FFh
		push	6Bh
		push	5Ah
		push	4Ah
highlight_back:
		push	0
		push	69
		mov		ecx, esi
		mov		edx, ADDR_CMenuManager__drawInputs
		call	edx
		mov		eax, ADDR_0057FCC2_CMenuManager__drawControls
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_0057FCCC_CMenuManager__drawControls() {
	static const float fWidth = 0.7f;
	//static const float fHeight = 1.0f;

	__asm {
		sub		esp, 8
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fmul	fWideScreenHeightScaleDown
		//fmul	fHeight
		fstp	dword ptr [esp+0E4h-0E0h]
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fmul	fWideScreenWidthScaleDown
		fmul	fWidth
		mov		eax, ADDR_0057FCE9_CMenuManager__drawControls
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_00582E21_CMenuManager__drawMapLegend() {
	static const float fSize = 16.0f;

	__asm {
		fmul	fSize
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fmul	fWideScreenWidthScaleDown
		fmul	fSize
		mov		ecx, ADDR_00582E27_CMenuManager__drawMapLegend
		jmp		ecx
	}
}

void __declspec(naked) HOOK_PTR_00588223_drawBlips() {
	__asm {
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fmul	ds:ADDR_fScreenHeightScale
		fmul	dword ptr [esp+5Ch-10h]
		fstp	dword ptr [esp+5Ch-10h]
		lea		edx, [esp+5Ch-10h]
		push	edx
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fmul	ds:ADDR_fScreenWidthScale
		fmul	dword ptr [esp+60h-14h]
		fstp	dword ptr [esp+60h-14h]
		lea		eax, [esp+60h-14h]
		push	eax
		mov		ecx, ADDR_0058822D_drawBlips
		jmp		ecx
	}
}

void __declspec(naked) HOOK_PTR_005886B9_drawBlips() {
	static const float fWidth = 8.0f;

	__asm {
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fmul	fWideScreenWidthScaleDown
		fmul	fWidth
		call	_ftol2
		mov		ebp, eax
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fmul	fWideScreenHeightScaleDown
		movzx	ecx, ds:[ADDR_clCamera]CCamera.m_cActiveCam
		imul	ecx, 238h
		cmp		ds:[ADDR_clCamera]CCamera.m_aclCams[ecx].m_bLocked, 1
		mov		edx, ADDR_005886DA_drawBlips
		jmp		edx
	}
}

void __declspec(naked) HOOK_PTR_00589709_drawStatistics() {
	static const float fPadX = 10.0f;
	static const float fBarX = 90.0f;
	static const float fPosX = 40.0f;

	__asm {
		fld		st
		fmul	fPosX
		fst		dword ptr [esp+38h-10h]
		fld		fPadX
		fmul	st, st(2)
		faddp	st(1), st
		call	_ftol2
		fmul	fBarX
		fadd	dword ptr [esp+38h-10h]
		mov		ecx, ADDR_00589728_drawStatistics
		jmp		ecx
	}
}

void __declspec(naked) HOOK_PTR_0058A68F_drawMap() {
	static const float fPosX = 15.0f;
	static const float fPosY = 28.0f;
	static const float fWidth = 20.0f;
	static const float fHeight = 2.0f;
	static const float fScrollHeight = 74.0f;
	static const float fPercent = 0.01f;

	__asm {
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fld		st
		fmul	fWideScreenHeightScaleDown
		mov		ecx, [eax]SRwV3d.m_fZ
		push	ecx
		call	getHeightPercentInWorldLevel
		add		esp, 4
		fmul	fPercent
		fmul	fScrollHeight
		fadd	fPosY
		fmul	st, st(1)
		fsubp	st(2), st
		fmul	fHeight
		fsubr	st, st(1)
		fstp	dword ptr [esp+34h-14h]
		fstp	dword ptr [esp+34h-1Ch]
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fmul	fWideScreenWidthScaleDown
		fld		fPosX
		fadd	fWidth
		fmul	st, st(1)
		fxch	st(1)
		fmul	fPosX
		mov		edx, ADDR_0058A73B_drawMap
		jmp		edx
	}
}

void __declspec(naked) HOOK_PTR_0058B1B4_drawOnScreenDisplays() {
	static const float fCounterPosY = 136.0f;
	static const float fCountersRelPosY = 20.0f;
	static const float fLongHealthMeterHeightPlusPad = 12.0f;
	static const float fPlayer2HudHeightPlusPad = 72.0f;

	__asm {
		fmul	fWideScreenHeightScaleDown
		fld		st
		fmul	fCounterPosY
		fld		st(1)
		fmul	fCountersRelPosY
		fadd	st, st(1)
		movzx	eax, ds:ADDR_ucPlayer
		imul	eax, 190h
		mov		cl, byte ptr ds:[ADDR_aclPlayers]CPlayer.m_cMaxHealth[eax]
		cmp		cl, 101
		ja		short_health_meter_0
		fld		st(2)
		fmul	fLongHealthMeterHeightPlusPad
		fld		st
		fsubp	st(3), st
		fsubp	st(1), st
short_health_meter_0:
		mov		edx, ds:[ADDR_aclPlayers]CPlayer.m_pclPed+190h
		test	edx, edx
		jz		player2_unavailable
		mov		al, ds:[ADDR_aclPlayers]CPlayer.m_cMaxHealth+190h
		cmp		al, 101
		ja		short_health_meter_1
		fld		st(2)
		fmul	fLongHealthMeterHeightPlusPad
		fld		st
		fsubp	st(3), st
		fsubp	st(1), st
short_health_meter_1:
		fld		st(2)
		fmul	fPlayer2HudHeightPlusPad
		fld		st
		faddp	st(3), st
		faddp	st(1), st
player2_unavailable:
		fstp	dword ptr [esp+0FCh-0ECh]
		fstp	dword ptr [esp+0FCh-0E8h]
		fstp	st
		mov		ecx, ADDR_0058B24C_drawOnScreenDisplays
		jmp		ecx
	}
}

void __declspec(naked) HOOK_PTR_0058BF9C_drawMessageBox() {
	__asm {
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fmul	fWideScreenHeightScaleDown
		fmulp	st(1), st
		mov		edx, ADDR_0058BFA2_drawMessageBox
		jmp		edx
	}
}

void __declspec(naked) HOOK_PTR_005A867B_drawCreditText() {
	static const float fPosY = 20.0f;
	static const float fOne = 1.0f;
	static const float fHalfOne = 0.5f;

	__asm {
		fsub	dword ptr [esp+4+14h]
		fst		dword ptr [esp+4+10h]
		fcom	fWideScreenHeightScaledInv
		fnstsw	ax
		test	ah, 41h
		jnz		before_lowest_height
		fld		fPosY
		fmul	fWideScreenHeightPerc
		fsubp	st(2), st
		fcompp
		fnstsw	ax
		test	ah, 5
		jp		beyond_highest_height
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fmul	ds:ADDR_fScreenHeightScale
		fld		st
		fmul	dword ptr [esp+4+10h]
		fstp	dword ptr [esp+4+10h]
		push	esi
		sub		esp, 8
		fmul	dword ptr [esp+10h+8]
		fstp	dword ptr [esp+10h-0Ch]
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fmul	fWideScreenWidthScaleDown
		fmul	dword ptr [esp+10h+4]
		fmul	fHalfOne
		fstp	dword ptr [esp+10h-10h]
		mov		eax, ADDR_005A86C0_drawCreditText
		jmp		eax
before_lowest_height:
		fstp	st
		fstp	st
beyond_highest_height:
		mov		ecx, ADDR_005A8790_drawCreditText
		jmp		ecx
	}
}

void __declspec(naked) HOOK_PTR_005A881E_drawCredits() {
	static const float fPosYScale = 1.0f / 20.0f;

	__asm {
		fmul	fWideScreenHeightMult
		fmul	fPosYScale
		mov		eax, ADDR_005A8824_drawCredits
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_005A883A_drawCredits() {
	static const float fPosY = 20.0f;

	__asm {
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fmul	fWideScreenHeightScaleDown
		fmul	fPosY
		fsubp	st(1), st
		mov		eax, ADDR_005A8840_drawCredits
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_0070CEAD_transform3DTo2DPointInClip() {
	__asm {
		mov		eax, [esp+14h+0Ch]
		mov		ecx, [esp+14h+10h]
		add		esp, 14h
		jmp		CODE_0_transform3DTo2DPoint
	}
}

void __declspec(naked) HOOK_PTR_0071A63C_getTextRect() {
	static const float fPad = 4.0f;

	__asm {
		add		esp, 10h
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fmul	fWideScreenHeightScaleDown
		fmul	fPad
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fmul	fWideScreenWidthScaleDown
		fmul	fPad
		test	cl, cl
		mov		edx, ADDR_0071A641_getTextRect
		jmp		edx
	}
}

void __declspec(naked) HOOK_PTR_0071DA42_transform3DTo2DPoint() {
	__asm {
		mov		eax, [esp+0Ch+0Ch]
		mov		ecx, [esp+0Ch+10h]
		add		esp, 0Ch
		jmp		CODE_0_transform3DTo2DPoint
	}
}

void __declspec(naked) CODE_0_transform3DTo2DPoint() {
	__asm {
		fld		ds:ADDR_fScreenFieldOfViewStd
		fdiv	ds:ADDR_fScreenFieldOfView
		fld1
		fdiv	[edx]SRwV3d.m_fZ
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenWidth
		fmul	st, st(1)
		fld		st
		fmul	[edx]SRwV3d.m_fX
		fstp	[edx]SRwV3d.m_fX
		fmul	fWideScreenWidthRatio
		fmul	st, st(2)
		fstp	dword ptr [eax]
		fild	ds:[ADDR_clRsGlobal]CRsGlobal.m_iScreenHeight
		fmulp	st(1), st
		fld		st
		fmul	[edx]SRwV3d.m_fY
		fstp	[edx]SRwV3d.m_fY
		fmul	fWideScreenHeightRatio
		fmulp	st(1), st
		fstp	dword ptr [ecx]
		retn
	}
}

void __declspec(naked) HOOK_PTR_007462BF_psSelectDevice() {
	__asm {
		mov		ds:[ADDR_iCurSelVideoMode], ecx
		mov		dl, cSelectedVideoRatio
		mov		ds:[ADDR_clMenuManager]CMenuManager.m_cVideoRatio, dl
		mov		cCurSelVideoRatio, dl
		mov		eax, ADDR_007462C5_psSelectDevice
		jmp		eax
	}
}

void __declspec(naked) HOOK_PTR_007462F4_psSelectDevice() {
	__asm {
		jz		device_not_set
		movsx	edx, cCurSelVideoRatio
		push	edx
		//call	rwEngineSetVideoRatio
		add		esp, 4
		test	eax, eax
		jz		device_not_set
		mov		ecx, ADDR_007462FA_psSelectDevice
		jmp		ecx
device_not_set:
		mov		edx, ADDR_007463D4_psSelectDevice
		jmp		edx
	}
}

void __declspec(naked) HOOK_OFF_04F2_rwD3d9System() {
	__asm {
		mov		ds:ADDR_iRwCurrentDisplayMode, ebp
		mov		iRwCurrentDisplayRatio, ebp
		mov		eax, JMP_OFF_04F8_rwD3d9System
		jmp		eax
	}
}

void __declspec(naked) CODE_0_rwD3d9System() {
	__asm {
		xor		ebp, ebp
		mov		ecx, pastRwDisplayRatioList
		test	ecx, ecx
		jz		display_ratio_list_not_present
		push	ecx
		mov		edx, free
		call	edx
		add		esp, 4
		mov		pastRwDisplayRatioList, ebp
		mov		iRwNumDisplayRatios, ebp
display_ratio_list_not_present:
		mov		eax, ds:ADDR_pastRwDisplayModeList
		mov		ecx, JMP_OFF_0539_rwD3d9System
		jmp		ecx
	}
}

void __declspec(naked) CODE_1_rwD3d9System() {
	__asm {
		mov		eax, pastRwDisplayRatioList
		test	eax, eax
		jnz		display_ratio_list_present
		call	rwD3d9CreateDisplayRatioList
display_ratio_list_present:
		mov		ecx, [esp+47Ch+8]
		mov		edx, iRwNumDisplayRatios
		mov		[ecx], edx
		mov		eax, JMP_OFF_0330_rwD3d9System
		jmp		eax
	}
}

void __declspec(naked) CODE_2_rwD3d9System() {
	__asm {
		mov		eax, pastRwDisplayRatioList
		test	eax, eax
		jnz		display_ratio_list_present
		call	rwD3d9CreateDisplayRatioList
display_ratio_list_present:
		mov		ecx, [esp+47Ch+10h]
		cmp		ecx, 0
		jl		wrong_display_mode_index
		mov		edx, ds:ADDR_iRwNumDisplayModes
		cmp		ecx, edx
		jge		wrong_display_mode_index
		lea		ecx, [ecx+ecx*4]
		shl		ecx, 2
		mov		edx, ds:ADDR_pastRwDisplayModeList
		lea		esi, [edx+ecx]
		mov		edi, [esp+47Ch+8]
		movsx	eax, [esi]SD3dDisplayMode.m_sRatioIndex
		mov		[edi], eax
		mov		ecx, JMP_OFF_0330_rwD3d9System
		jmp		ecx
wrong_display_mode_index:
		mov		edx, JMP_OFF_0AA0_rwD3d9System
		jmp		edx
	}
}

void __declspec(naked) CODE_3_rwD3d9System() {
	__asm {
		mov		eax, [esp+47Ch+8]
		mov		ecx, iRwCurrentDisplayRatio
		mov		[eax], ecx
		mov		edx, JMP_OFF_0330_rwD3d9System
		jmp		edx
	}
}

void __declspec(naked) CODE_4_rwD3d9System() {
	__asm {
		mov		eax, pastRwDisplayRatioList
		test	eax, eax
		jnz		display_ratio_list_present
		call	rwD3d9CreateDisplayRatioList
display_ratio_list_present:
		mov		ecx, [esp+47Ch+10h]
		cmp		ecx, 0
		jl		wrong_display_ratio_index
		mov		edx, iRwNumDisplayRatios
		cmp		ecx, edx
		jge		wrong_display_ratio_index
		mov		iRwCurrentDisplayRatio, ecx
		shl		ecx, 4
		lea		esi, [eax+ecx]
		mov		edi, [esp+47Ch+8]
		fld		[esi]SRwD3d9DisplayRatio.m_fRatio
		fst		[edi]SRwD3d9DisplayRatio.m_fRatio
		mov		eax, [esi]SRwD3d9DisplayRatio.m_iNumerator
		mov		[edi]SRwD3d9DisplayRatio.m_iNumerator, eax
		mov		ecx, [esi]SRwD3d9DisplayRatio.m_iDenominator
		mov		[edi]SRwD3d9DisplayRatio.m_iDenominator, ecx
		mov		edx, [esi]SRwD3d9DisplayRatio.m_iAdapter
		mov		[edi]SRwD3d9DisplayRatio.m_iAdapter, edx
		fcomp	fScreenAspectRatioAcd
		fnstsw	ax
		test	ah, 41h
		jnz		not_widescreen_resolution
		mov		[edi]SRwVideoRatio.m_bWidescreen, 1
		jmp		widescreen_resolution
not_widescreen_resolution:
		mov		[edi]SRwVideoRatio.m_bWidescreen, 0
widescreen_resolution:
		mov		ecx, JMP_OFF_0330_rwD3d9System
		jmp		ecx
wrong_display_ratio_index:
		mov		edx, JMP_OFF_0AA0_rwD3d9System
		jmp		edx
	}
}

void __declspec(naked) CODE_5_rwD3d9System() {
	__asm {
		mov		eax, pastRwDisplayRatioList
		test	eax, eax
		jnz		display_ratio_list_present
		call	rwD3d9CreateDisplayRatioList
display_ratio_list_present:
		mov		ecx, [esp+47Ch+10h]
		cmp		ecx, 0
		jl		wrong_display_ratio_index
		mov		edx, iRwNumDisplayRatios
		cmp		ecx, edx
		jge		wrong_display_ratio_index
		mov		iRwCurrentDisplayRatio, ecx
		shl		ecx, 4
		lea		esi, [eax+ecx]
		lea		edi, stRwDisplayRatio
		fld		[esi]SRwD3d9DisplayRatio.m_fRatio
		fst		[edi]SRwD3d9DisplayRatio.m_fRatio
		mov		eax, [esi]SRwD3d9DisplayRatio.m_iNumerator
		mov		[edi]SRwD3d9DisplayRatio.m_iNumerator, eax
		mov		ecx, [esi]SRwD3d9DisplayRatio.m_iDenominator
		mov		[edi]SRwD3d9DisplayRatio.m_iDenominator, ecx
		mov		edx, [esi]SRwD3d9DisplayRatio.m_iAdapter
		mov		[edi]SRwD3d9DisplayRatio.m_iAdapter, edx
		mov		eax, JMP_OFF_0330_rwD3d9System
		jmp		eax
wrong_display_ratio_index:
		mov		ecx, JMP_OFF_0AA0_rwD3d9System
		jmp		ecx
	}
}

void __declspec(naked) HOOK_OFF_01_rwD3d9Release() {
	__asm {
		push	ebx
		xor		ebx, ebx
		mov		ecx, pastRwDisplayRatioList
		test	ecx, ecx
		jz		display_ratio_list_not_present
		push	ecx
		mov		edx, free
		call	edx
		add		esp, 4
		mov		pastRwDisplayRatioList, ebx
		mov		iRwNumDisplayRatios, ebx
display_ratio_list_not_present:
		mov		eax, ds:ADDR_pastRwDisplayModeList
		mov		ecx, JMP_OFF_09_rwD3d9Release
		jmp		ecx
	}
}
